
/* 
 * LCAUView.m -- Implementation file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, or even that it has a use.
 * revisada agosto 25 1995
 */

#import "LCAUView.h"
#import "drawingFuncs.h"
#import "nxlcau42.h"
//#import "nxardn42.h"
// #import "nxprob42.h"
//#import "nxcycl42.h"
//#import "nxrijn42.h"
#import <math.h> 
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>

extern  int binrule[KK][KK][KK][KK][KK];
extern char ascrule[KK][KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK][KK];

int    i,j;

int    drawArhi=NO;
int    drawBasin=NO;
int    drawCross=NO;
int    drawMonc=NO;
int    drawEvol=NO;
int    drawLine=NO;
int    drawReturn=NO;
int    drawShort=NO;
int    drawTMatrix=NO;
int    drawMeanF=NO;
int    draw2Block=NO;
int    drawXBlock=NO;
int    drawNBlk=NO;
int    showStat=NO;
int    drawPlaid=NO;
int    drawview=0;
int    Vmode, Vpall;

//int    rijnPerm=0;
//int    rijnShift=0;
//int    rijnGen=1;
//int    probEIV='e';
//int    probBlkV='1';
//char                      aarry[KK][KK][KK];
//char                  barry[KK][KK][KK][KK][KK];
//char               carry[KK][KK][KK][KK][KK][KK][KK];
//char           darry[KK][KK][KK][KK][KK][KK][KK][KK][KK];
//char       earry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
//char   farry[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];

//extern int    amat[KK][KK][KK][KK];
//extern int    bmat[KK][KK][KK][KK];
//extern int    cmat[KK][KK][KK][KK];
//extern int    fmat[KK][KK][KK][KK];
//extern int    gmat[KK][KK][KK][KK];
//extern int    hmat[KK][KK][KK][KK];
//extern int    xmat[KK][KK][KK][KK];
//extern int    tmat[KK][KK][KK][KK][KK][KK][KK][KK];
//extern int    umat[KK][KK][KK][KK][KK][KK][KK][KK];
//extern int    vmat[KK][KK][KK][KK][KK][KK][KK][KK];

//int    srule[2][27];
//int    cu=12;

//double  cntr[2187][2];
//double pcntr[PDN][2];
//double scntr[SDN][2];

//double cubic[25][25][25];

NXColor colst[KK];
extern char colorwells[KK][6];
/* Declaracion de colores por medio de una matrix de color
 * double rgbcolr [KK][3] = {0.0,0.0,0.0,
 *                           0.5,0.5,0.5,
 *                           1.0,1.0,1.0,
 *                           0.1,0.1,1.0};
 */

//extern double blpr[KK];	/* probability from blocks	*/

//extern int    cc, dd;		/* radius of de Bruijn ring */
extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern float  getNumber(NXStream *stream);
extern int    getSeparator(NXStream *stream);

int    ardnll;
extern double stt, sta[5][K3+1];

int      ix3(int i, int j, int k);
void     serms(double x, double y, int l, int m);
void     shortevolve(int m, int n);
void     tcolordot(double *p, double *c);
//void     wru(char *c);

void asctobin();
void evolve();
void onegen(int n);
void pgrid();
void pprob();
void ranblin(double p, double q, double r, double s);
void ranlin();
void renewarry();
void savearry();
void xblnk();

#define MAXNUMLENGTH 50
#define DEFAULTRADIUS 1.0

@implementation LCAUView

void videocursor(p,i,j) int p, i, j; {}
void videoputc(c,i) char c; int i; {}
void videomode(i) int i; {Vmode=i;}
void videopalette(i) int i; {Vpall=i;}
void videocattr(p,c,n,l) int p, c, n, l; {}
void videoscroll(i,j,k,l,d,c) int i, j, k, l, d, c; {}

void videodot(i,j,l) int i, j, l; {
  switch (l) {
    case 0: if (drawview==2) PSsetrgbcolor(0.7,1.0,0.6); 
		else PSsetrgbcolor(1.0,1.0,0.8); break;
   case 1: NXSetColor(colst[0]); break;
   case 2: NXSetColor(colst[1]); break;
   case 3: NXSetColor(colst[2]); break;
   case 4: NXSetColor(colst[3]); break;
           default: break;}

/*  PSsetgray(NX_BLACK); */
 
/*   drawCircle(y,x,1.0); */

    switch (drawview) {
      case 0: PSrectfill(2.0*(float)j,2.0*(float)i,1.25,1.25); break;
      case 1: PSrectfill(2.0*(float)i,398.0-2.0*(float)j,1.25,1.25); break;
      case 2: PSrectfill(8.0*(float)j+1.5,60.0-8.0*(float)i,4.75,4.75); break;
      case 3: PSrectfill(4.0*(float)j+1.0,4.0*(float)i,3.0,3.0); break;
      case 4: PSrectfill(2.0*(float)j,100.0-2.0*(float)i,1.25,1.25); break;
      case 5: PSrectfill(2.0*(float)j,2.0*(float)i,1.5,1.5); break;
      case 6: PSrectfill(10.0*(float)j,10.0*(float)i,9.0,9.0); break;
      case 7: PSrectfill(4.0*(float)j,4.0*(float)i,3.125,3.125); break;
      case 8: PSrectfill(150.0+(float)j,260.0-(float)i,1.0,1.0); break;
      case 9: PSrectfill(2.0*(float)j,173.0-2.0*(float)i,1.5,1.5); break;
      default: break;}
 }

//void tcolordot(p,c) double p[3], c[3]; {double s;
//  s=1.0/(p[0]+p[1]+p[2]);
//  PSsetcmykcolor(c[0],c[1],c[2],0.0);
//  PSrectfill(200.0*(p[1]+0.5*p[2])*s,173.0-200.0*p[2]*s*0.866,1.5,1.5);
//} Esta creo no es necesaria

/* m = line length; n = number of lines */

void shortevolve(m,n) int m, n; {
int i, j, o;
  savearry();
  asctobin();
  o=AL/2-m/2;
  for (j=0; j<n; j++) {
    for (i=0; i<m; i++) videodot(j,i,arr1[i+o]+1);
    onegen(AL);
    }
  renewarry();
}

/* index three dimensions */
//int ix3(i,j,k) int i, j, k; {return (cu+i)%cu+ cu*((cu+j)%cu+ cu*((cu+k)%cu ));}


/* --------------------------- T I M E  -  D A T E-------------------------- */
/* notacion de comentarios puesta por el Dr. McIntosh */
// #include <stdio.h>
// #include <stdlib.h>
// #include <time.h>

/* 
    Turbo C Reference Guide Version 2.0 (1988)
    Borland International.
    Chapter2, The Turbo C library, pag. 226.
*/

// main(void)
// {
//   struct tm  *timeptr;
//   time_t  secsnow;

/*  timezone = 8*60*60; */
//   time(&secsnow);
//   timeptr = localtime(&secsnow);
//   printf("The data is %d-%d-19%02d\n",
//          ((timeptr->tm_mon) + 1), timeptr->tm_mday,
//           timeptr->tm_year);
//   printf("Local time is %02d:%02d:%02d\n",
//          timeptr->tm_hour, timeptr->tm_min,
//         timeptr->tm_sec);
// }

/* ----------------------------- G E N E R A L ----------------------------- */

/* Metodo para definir colores por medio de una matrix
 * - colorStates:sender 
 *   {int i, j;
 *      for (i=0; i<KK; i++) for (j=0; j<3; j++) 
 *	rgbcolr[i][j]=[[colorMatrix cellAt: i: j] doubleValue];
 *	[[colorMatrix cellAt: i: j] setDoubleValue: setColor[i]];
 *    return self;
 *    }
 */
- updateColors:sender
{
//printf("hello from upcolors with tag %d\n",[sender tag]);
  colst[[sender tag]]=[sender color];
return self;
}

- saveColors:sender 
{char c[32]; int i;
  for (i=0; i<KK; i++) {
    sprintf(c,"%6.3f, %6.3f, %6.3f",
	NXRedComponent(colst[i]),
  	NXGreenComponent(colst[i]),
	NXBlueComponent(colst[i])
	);
    NXWriteDefault("NXLCAU42Defaults",colorwells[i],c);
	};
return self;
}

- revertColors:sender 
{char c[32], *df; int i; double red, green, blue;
  for (i=0; i<KK; i++) {
    sprintf(c,"%6.3f, %6.3f, %6.3f",
	NXRedComponent(colst[i]),
  	NXGreenComponent(colst[i]),
	NXBlueComponent(colst[i])
	);
    NXWriteDefault("NXLCAU42Defaults",colorwells[i],c);
	};
  for (i=0; i<KK; i++) {
    df=NXGetDefaultValue("NXLCAU42Defaults",colorwells[i]);
    sscanf(df,"%6lf,%6lf,%6lf",&red,&green,&blue); /* don't use %F */
    colst[i]=NXConvertRGBToColor(red,green,blue);
    printf("%s: %s\n",colorwells[i],df);
    }
return self;
}

/* ------------------------- E V O L U T I O N ------------------------- */

- plotDot:sender
{
return self;
}

- makeline:sender
{
  char *s; double p, p0, p1, p2, p3;
    s=[[sender selectedCell] title];
    printf("Line - %s\n",s);
    switch (s[0]) {
      case 'h':
        printf("random line\n");
        p=0.5;
	ranblin(0.25,0.25,0.25,0.25);
        printf("%6.3f \n",p);
        break;
      case 'r':
        printf("random line\n");
        p0=[[pslid cellAt: 0: 0] floatValue];
        p1=[[pslid cellAt: 0: 0] floatValue];
        p2=[[pslid cellAt: 0: 0] floatValue];
        p3=[[pslid cellAt: 0: 0] floatValue];
	p=p0+p1+p2+p3;
	p0/=p; p1/=p; p2/=p; p3/=p;
	ranlin();
        break;
      case 's':
        printf("single cell\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
	    arr1[AL/4]=1;
               arr1[AL/2]=1;
               arr1[(3*AL)/4]=1;
               arr1[(3*AL)/4+2]=1;
/*	    lmenu(); */
        break;
      case 'z':
        printf("zero line\n");
	    xblnk();
	    for (i=0; i<AL; i++) arr1[i]=0;
/*	    lmenu(); */
	break;
      default: break;}

    drawview=2;
    drawLine=YES;
    [self display];
    drawLine=NO;

return self;
}

- drawShEvol:sender
{
    drawview=7;
    drawShort=YES;
    [self clear: self];
    [self display];
    drawShort=NO;

return self;
}

- printShEvol:sender
{
    drawview=7;
    drawShort=YES;
    [self clear: self];
    [wholePanel smartPrintPSCode: self];
    drawShort=NO;
return self;
}

- drawEvolu:sender
{
  drawview=0;
  drawEvol=YES;
  [self display];
  drawEvol=NO;
	needsClearing = YES;
return self;
}

- printEvolu:sender
{
  drawview=1;
  drawview=0;
  drawEvol=YES;
    [wholePanel smartPrintPSCode: self];
    [self printPSCode:self];
  drawEvol=NO;
return self;
}

- drawPlaid:sender
{
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
  [self display];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;
return self;
}

- printPlaid:sender
{
  drawview=5;
  [self setFlipped: NO];
  drawPlaid=YES;
    [wholePanel smartPrintPSCode: self];
  drawPlaid=NO;
  [self setFlipped: YES];
	needsClearing = YES;

return self;
}

/* -------------------------------- L C A U -------------------------------- */

/* -------------------------------- A R D N -------------------------------- */

//- arsq:sender
//{
//int    a, b, i, j, i0, i1, op;
//int    c[KK][KK], r[KK][KK];
//int    u[KK][KK], v[KK][KK];
//char   ch[20];
//double f, ff, g, gg, gl, gr, tt, h, kay;
//double cc[KK][KK], rr[KK][KK];
//double uu[KK][KK], vv[KK][KK];
//double s, t, bb, utu, utv, vtv, co;

//op=0;
//  [aPower setIntValue: ardnll];
/* siguientes 3 puestos por el Dr McIntosh*/
// if (strcmp([[lambdaStyle selectedCell] title],"vectors")==0) op=0;
// if (strcmp([[lambdaStyle selectedCell] title],"lambda")==0) op=1;
// if (strcmp([[lambdaStyle selectedCell] title],"Z")==0) op=2;

//if (strcmp([[sender selectedCell] title],"initialize")==0) {
//   wru(ch);
//   [ruleNumber setStringValue: ch];
//   [aEigenvalue setStringValue: ""];
//asctobin();
//zmat(amat);  djmat(amat,0);
//zmat(bmat);  djmat(bmat,1);
//zmat(cmat);  djmat(cmat,2);
//zzmat(tmat); tensq(tmat,amat,bmat,cmat);
//unmat(umat);
//zmat(gmat);
//zmat(xmat);
//  }
//if (strcmp([[sender selectedCell] title],"t matrix")==0) {
//       ccymat(umat,tmat);
//  [self tPrint:self]; /*puesto por el Dr. McIntosh */
//  ardnll=1;
//  [aPower setIntValue: ardnll];
//  }
//if (strcmp([[sender selectedCell] title],"times t")==0) {
//	mmmat(vmat,tmat,umat);
//	ccymat(umat,vmat);
//  [self tPrint:self]; /*puesto por el Dr McIntosh */
//  ardnll++;
//  [aPower setIntValue: ardnll];
//  }
//if (strcmp([[sender selectedCell] title],"square")==0) {
//	mmmat(vmat,umat,umat);
//	ccymat(umat,vmat);
//  [self tPrint:self]; /*puesto por el Dr. McIntosh */
//  ardnll+=ardnll;
//  [aPower setIntValue: ardnll];
//  }
//if (strcmp([[sender selectedCell] title],"lambda")==0) {
//	t=ttsum(umat);
//	f=(double)t;
//	mmmat(vmat,tmat,umat);
//	t=ttsum(vmat);
//	ff=f; f=(double)t;
//	h=h*kay;
//	gg=g; g=f/h;
//DrMc	videocursor(0,22,18); printf("%7u [%3u]%6.3f  ",t,s,f/ff);
//  [aEigenvalue setDoubleValue: f/ff];
//DrMc	videocursor(0,23,20); printf("m[2] ratio:%6.3f ",sqrt(f/ff));
//	gr=g/gg; gl=0.0; if (gr>0.0) gl=log(gr);
//DrMc	go=g*exp(-((double)(ll-1))*gl);
//DrMc	videocursor(0,24,20); printf("%5.3f exp(%6.3fn)",sqrt(go),0.5*gl);
//	tt=1;
//        }

//DrMc	auua(&xave,&xsig,&ex,&wy,cvec,xvec,umat);

//    drawview=7;
//    drawTMatrix=YES;
//    [self display];
//    drawTMatrix=NO;

//return self;
//}

- arhi:sender
{
    drawview=5;
    drawArhi=YES;
    [self display];
    drawArhi=NO;
  [pButton setEnabled: YES];
  [sButton setEnabled: YES];
	needsClearing = YES;
return self;
}

- printArhi:sender
{
    drawview=5;
    drawArhi=YES;
    [wholePanel smartPrintPSCode: self];
    drawArhi=NO;
return self;
}

//- printTMatrix:sender
//{
//    drawview=7;
//    drawTMatrix=YES;
//    [wholePanel smartPrintPSCode: self];
//    drawTMatrix=NO;
//return self;
//}

/* -------------------------------- R I J N -------------------------------- */

//- rijnRanSam:sender
//{
// int i;
//  i='z';
//  if (strcmp([[sender selectedCell] title],"random sample")==0) i='r';
//  if (strcmp([[sender selectedCell] title],"selected node")==0) i='n';
//  if (strcmp([[sender selectedCell] title],"scan links")==0)    i='i';

//  if ([dTwig state]) {[self clear: self]; return self;}
//  edshf(rijnGen,rijnShift,i);
//    drawview=3;
//    drawShort=YES;
//    [self clear: self];
//    [self display];
//    drawShort=NO;
//	needsClearing = YES;
//return self;
//}

/* -------------------------------- P R O B -------------------------------- */

- prob:sender
{
return self;
}

- probHowMany:sender
{
return self;
}

- probSetBlk:sender 
{
//  probBlkV=[[sender selectedCell] title][0];
return self;
}

- showBasin:sender
{
//    drawBasin=YES;
//    [self display];
//    drawBasin=NO;
//	needsClearing = YES;
return self;
}

- printBasin:sender
{
//    drawBasin=YES;
//    [wholePanel printPSCode:self];
//    drawBasin=NO;
//	needsClearing = YES;
return self;
}

- drawProb:sender
{
//    drawview=9;
//    drawMeanF=YES;
//    [self display];
//    drawMeanF=NO;
//	needsClearing = YES;
return self;
}

- printProb:sender
{
//  drawview=9;
//   drawMeanF=YES;
//   [wholePanel printPSCode:self];
//   drawMeanF=NO;
return self;
}

- drawBlock:sender
{
//    drawview=8;
//    draw2Block=YES;
//    [self display];
//    draw2Block=NO;
//	needsClearing = YES;
return self;
}

- printBlock:sender
{
//  drawview=8;
//   draw2Block=YES;
//  [wholePanel smartPrintPSCode:self];
//   draw2Block=NO;
return self;
}

- drawNBlock:sender
{
//    drawview=4;
//    drawNBlk=YES;
//    [self display];
//    drawNBlk=NO;
//	needsClearing = YES;
return self;
}

- printNBlock:sender
{
//   drawview=4;
//   drawNBlk=YES;
//   [wholePanel smartPrintPSCode:self];
//   drawNBlk=NO;
return self;
}

- showXBlock:sender
{
//    drawview=4;
//    drawXBlock=YES;
//    [self display];
//    drawXBlock=NO;
//	needsClearing = YES;
return self;
}

- printXBlock:sender
{
//   drawview=4;
//   drawXBlock=YES;
//   [wholePanel smartPrintPSCode:self];
//   drawXBlock=NO;
return self;
}

- drawStat:sender
{
//    drawview=5;
//    showStat=YES;
//    [self display];
//    showStat=NO;
//	needsClearing = YES;
return self;
}

- printStat:sender
{

//   drawview=5;
//   showStat=YES;
//   [wholePanel smartPrintPSCode:self];
//   showStat=NO;
return self;
}

//- nxmoncar: (int) l
//{
//int i, j, k, n, b[KK], bb[KK][KK];
//double bf[KK], bbf[KK][KK];
//double a[KK], aa[KK], d[KK], el, en, t, tt, s;

// nblclr(); /*DrMc */
//n=[[statLines selectedCell] tag];
//asctobin();
//el=1.0/((double)AL);
//en=1.0/((double)n);
//for (i=0; i<KK; i++) {a[i]=0.0; aa[i]=0.0;}
//for (k=0; k<n; k++) {
//  onegen(AL);
//  for (i=0; i<KK; i++) b[i]=0;
//  for (i=0; i<AL; i++) b[arr1[i]]++;
//  for (i=0; i<KK; i++) bf[i]=((double)(b[i]))*el;
//  for (i=0; i<KK; i++) {a[i]+=bf[i]; aa[i]+=bf[i]*bf[i];}
//  for (i=0; i<KK; i++) for (j=0; j<KK; j++) bb[i][j]=0;
//  for (i=1; i<AL; i++) bb[arr1[i-1]][arr1[i]]++;
//  bb[arr1[AL-1]][arr1[0]]++; 
//  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
//    bbf[i][j]=((double)(bb[i][j]))*el;
//  videodot(199-(int)(100.0*bbf[1][1]),BORG+(int)(100.0*bf[1]),l); *DrMc*
//  }  
//for (i=0; i<KK; i++) {a[i]*=en; aa[i]*=en;}
//s=1.0/log((double)KK);
//t=0.0; tt=0.0;
//for (i=0; i<KK; i++) t+=bf[i]*log(bf[i]);
//for (i=0; i<KK; i++) d[i]=sqrt(aa[i]-a[i]*a[i]);
//for (i=0; i<KK; i++) for (j=0; j<KK; j++) tt+=bbf[i][j]*log(bbf[i][j]);
//  [statLamb setDoubleValue: 1.0-bf[0]];
//  [statEntro setDoubleValue: -t*s];
//  [statEnpai setDoubleValue: -0.5*tt*s];
// printf("average      = %5.3f, %5.3f, %5.3f\n",a[0],a[1],a[2]);
// printf("deviation    = %5.3f, %5.3f, %5.3f\n",d[0],d[1],d[2]);
//	[statSDevi setDoubleValue: (d[0]+d[1]+d[2])/3.0];
//  for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: bf[i]];
//  for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
//	[[statPair cellAt: 0: i*KK+j] setDoubleValue: bbf[i][j]];
//return self;
//}

/* -------------------------------- * * * * -------------------------------- */

/* place a dot within range (-2.0, 2.0)	at */
/* coordinate (x,y), visibility l, color m */

void serms(x,y,l,m) double x, y; int l, m; {
  if (x > 600.0 || x < 0.0 || y > 400.0 || y < 0.0 ) return;
  switch (l) {
    case 0: PSsetrgbcolor(1.0,1.0,1.0); break;
    case 1: PSsetrgbcolor(0.0,0.0,0.0); break;
    default: break;}
/*  PSsetgray(NX_BLACK); */
 
/*   drawCircle(y,x,1.0); */
     PSrectfill(x,y,1.25,1.25);
}

/* - - - - - - - - - - - - L C A U V i e w - - - - - - - - - - - - - - - - - */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LCAUView object.  First, an initFrame: message is sent 
 * to super to initialize LCAUView as a View.  Next, the LCAUView sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	[self setRadius:DEFAULTRADIUS];
	points = [[Storage alloc] initCount:0 elementSize:sizeof(NXPoint) description:"{ff}"];
	crossCursor = [NXCursor newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];
	/* 
	 * Normally, the next two message expressions would be combined, as:
	 * 		readOut = [[Cell alloc] initTextCell:""];
	 * but are here separated for clarity.
	 */
	readOut = [Cell alloc];
	[readOut initTextCell:"pointies"];
	[readOut setBezeled:YES];
	loadPSProcedures();



  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

//    videocursor(0,0,0);
//    PSshow("...LCAU21..."); 

  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LCAUView's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LCAUView's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LCAUView only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[30];
	unsigned int	 i, j, k, l, n;
	int		 ii, jj, nn, bas;
           double           en, p, q, s, t, dp, pee, cue;
	double		 aa[KK], bb[KK], cc[KK], cq[KK];
	double		 bern(), dbern(), tbern(), fbern();
	NXPoint		 *aPoint;
	NXRect		 plotRect;

  struct tm  *timeptr;
  time_t  secsnow;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* 
	 * If we're printing, we need to load drawing procedures to the 
	 * printing context. This simple test is OK for a View that prints 
	 * a single page. If there were multiple pages, the procedures would 
	 * be loaded multiple times. Although this is inefficient, it causes 
	 * no error. Views that print multiple pages should load procedures 
	 * such as these in an endPrologue method (see the View spec sheet). 
	 */
	if (NXDrawingStatus != NX_DRAWING) 
		loadPSProcedures();

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	NXRectFill(&rects[0]);

//	PSsetgray(NX_DKGRAY); *DrMc*
// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height); *DrMc*


        if (drawEvol==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
	  if ([keepTop state]) savearry();
	  evolve();
	  if ([keepTop state]) renewarry();
	  }

        if (drawShort==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
  	  [self getBounds:&plotRect];
	  i=(int)(plotRect.size.width/4.0);
	  j=(int)(plotRect.size.height/4.0);
	  shortevolve(i,j);
	}

	if (drawPlaid==YES) {		/* one cycle of evolution */
		n=[[gridSize selectedCell] tag];
	    pgrid();
	    asctobin();
	    for (i=0; i<1024; i++) {pprob(); onegen(AL);}
		PSsetgray(NX_BLACK); 
		PSsetlinewidth(0.0);
		if (n>0) {
		    for (j=1, dp=200.0, i=0; i<n; i++) {j*=3; dp*=0.333;}
		    for (i=0, p=1.0; i<j+1; i++, p+=dp) {
			PSmoveto(0.1,p);
			PSlineto(201.0,p);
			PSmoveto(p,0.1);
			PSlineto(p,201.0);
			}
		    PSstroke();
		    }
//   wru(c);
//   [ruleNumber setStringValue: c];
//	}
//   wru(c);
//   [ruleNumber setStringValue: c];
	}


//        if (drawMeanF==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
//	if ([[probEI cellAt:5:0] state]) lifreq(100,0,0,2);
//	if ([[probEI cellAt:4:0] state]) pdiff(100,6);
//	if ([[probEI cellAt:3:0] state]) pddiff(100,6);
//	if ([[probEI cellAt:2:0] state]) ptdiff(100,6);
//	if ([[probEI cellAt:1:0] state]) pfdiff(100,6);
//	if ([[probEI cellAt:0:0] state]) pvdiff(100,6);

//	if ([[probEI cellAt:4:1] state]) pidiff(100,6,1);
//	if ([[probEI cellAt:3:1] state]) pidiff(100,6,2);
//	if ([[probEI cellAt:2:1] state]) pidiff(100,6,3);
//	if ([[probEI cellAt:1:1] state]) pidiff(100,6,4);
//	if ([[probEI cellAt:0:1] state]) pidiff(100,6,5);

//	if ([probGrid state]) {
//	     PSsetlinewidth(0.0);
//	     PSsetgray(NX_BLACK);
//	     linegrid(10);
//	     PSstroke();
//	     }

//DrMc	  for (i=0; i<6; i++) if ([[probEI cellAt:i:0] state]) procur('e',5-i);
//DrMc	  for (i=0; i<6; i++) if ([[probEI cellAt:i:1] state]) procur('i',5-i);
//		}

//	if (drawBasin==YES) {
/* graph the probability differential for state l over 	*/
/* an extended triangle 	 			*/
//   wru(c);
//   [ruleNumber setStringValue: c];
//	if ([[probEI cellAt:5:0] state]) bas=0; 
//	if ([[probEI cellAt:4:0] state]) bas=1;
//	if ([[probEI cellAt:3:0] state]) bas=2;
//	if ([[probEI cellAt:2:0] state]) bas=3; 
//	if ([[probEI cellAt:1:0] state]) bas=4;
//	if ([[probEI cellAt:0:0] state]) bas=5;

//	if ([[probEI cellAt:4:1] state]) bas=6;
//	if ([[probEI cellAt:3:1] state]) bas=7;
//	if ([[probEI cellAt:2:1] state]) bas=8;
//	if ([[probEI cellAt:1:1] state]) bas=9;
//	if ([[probEI cellAt:0:1] state]) bas=10;

//nn=100;
//en=1.0/((double)(nn));
// for (ii=-nn; ii<=3*nn; ii++) { *DrMc*
//   for (jj=-nn; ii+jj<=2*nn; jj++) { *DrMc*
//for (ii=0; ii<=nn; ii++) {
//for (jj=0; ii+jj<=nn; jj++) {
//    aa[0]=((double)(ii))*en;
//    aa[1]=((double)(jj))*en;
//    aa[2]=1.0-aa[0]-aa[1];
//    switch (bas) {
//      case 0: cq[0]=aa[0]; cq[1]=aa[1]; cq[2]=aa[2];
//              break;
//      case 1: cq[0]=bern(0,aa); cq[1]=bern(1,aa); cq[2]=bern(2,aa);
//              break;
//      case 2: cq[0]=dbern(0,aa); cq[1]=dbern(1,aa); cq[2]=dbern(2,aa);
//	      break;
//      case 3: cq[0]=tbern(0,aa); cq[1]=tbern(1,aa); cq[2]=tbern(2,aa);
//	      break;
//      case 4: cq[0]=fbern(0,aa); cq[1]=fbern(1,aa); cq[2]=fbern(2,aa);
//	      break;
//      case 5: break;

//      case 6: cq[0]=bern(0,aa); cq[1]=bern(1,aa); cq[2]=bern(2,aa);
//              break;
//      case 7: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
//	      cq[0]=bern(0,bb); cq[1]=bern(1,bb); cq[2]=bern(2,bb);
//              break;
//      case 8: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
//	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
//	      cq[0]=bern(0,cc); cq[1]=bern(1,cc); cq[2]=bern(2,cc);
//	      break;
//      case 9: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
//	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
//	      bb[0]=bern(0,cc); bb[1]=bern(1,cc); bb[2]=bern(2,cc);
//	      cq[0]=bern(0,bb); cq[1]=bern(1,bb); cq[2]=bern(2,bb);
//	      break;
//      case 10: bb[0]=bern(0,aa); bb[1]=bern(1,aa); bb[2]=bern(2,aa);
//	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
//	      bb[0]=bern(0,cc); bb[1]=bern(1,cc); bb[2]=bern(2,cc);
//	      cc[0]=bern(0,bb); cc[1]=bern(1,bb); cc[2]=bern(2,bb);
//	      cq[0]=bern(0,cc); cq[1]=bern(1,cc); cq[2]=bern(2,cc);
//	      break;
//      default: break;
//      }
//   if ([probFlip state]) tcolordot(cq,aa); else tcolordot(aa,cq);
//    }
//  }
//	     PSstroke();

//	if ([probGrid state]) {
//	     PSsetlinewidth(0.0);
//	     PSsetgray(NX_BLACK);
//	     linegrid(10);
//	     PSstroke();
//	     }

//	}

//	if (draw2Block==YES) {
//    wru(c);
//    [ruleNumber setStringValue: c];
//    switch([pswit selectedRow]) {
//      case 0: xpdiff(100,6); break;
//      case 1: psddiff(100,6); break;
//      default: break;}
//	     PSsetlinewidth(0.05);
//	     PSsetgray(NX_BLACK);
//	     xlinegrid(10);
//	     PSstroke();
//	     PSsetlinewidth(0.0);
//           }

//	if (drawXBlock==YES) {

// printf("hello from XBlock\n"); *DrMc*

//   wru(c);
//   [ruleNumber setStringValue: c];

//   time(&secsnow);
//   timeptr = localtime(&secsnow);
//   sprintf(c,"%d-%d-19%02d\n",
//	((timeptr->tm_mon) + 1), 
//	timeptr->tm_mday,
//        timeptr->tm_year);
//   [tiDat setStringValue: c];

//    l=0;
//    if (strcmp([[probView selectedCell] title],"front")==0) l=0;
//    if (strcmp([[probView selectedCell] title],"plan")==0) l=1;
//    if (strcmp([[probView selectedCell] title],"side")==0) l=2;

//    if ([[probLevel cellAt: 0: 0] state]) {
//	  PSsetlinewidth(0.0);
//	  PSsetcmykcolor(0.2,0.0,1.0,0.0);
//	cudem(cubic,25,25,25,6);
//    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
//      conth(cubic,0.0,i,j,k,l);
//	}
//		PSstroke();
//      }
//    if ([[probLevel cellAt: 1: 0] state]) {
//	  PSsetlinewidth(0.0);
//	  PSsetcmykcolor(0.0,1.0,0.2,0.0);
//	cudem(cubic,25,25,25,7);
//    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
//      conth(cubic,0.0,i,j,k,l);
//	}
//		PSstroke();
//      }
//    if ([[probLevel cellAt: 2: 0] state]) {
//	  PSsetlinewidth(0.0);
//	  PSsetcmykcolor(1.0,0.0,0.2,0.0);
//	cudem(cubic,25,25,25,8);
//    for (i=0; i<24; i++) for (j=0; j<24; j++) for (k=0; k<24; k++) {
//      conth(cubic,0.0,i,j,k,l);
//	}
//		PSstroke();
//      }
//    }

//	if (drawNBlk==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
//	  nblcur(probBlkV);
//	  for (i=0; i<KK; i++) [[haHa cellAt: 0: i] setDoubleValue: blpr[i]];
//	  }

//	if (showStat==YES) {
//   wru(c);
//   [ruleNumber setStringValue: c];
//DrMc	  if (strcmp([[statMode selectedCell] title],"static")==0) [self nxasfreq];
//	  if (strcmp([[statMode selectedCell] title],"dynamic")==0) {
//	    if (strcmp([[statNhood selectedCell] title],"totalistic")==0) {
//		[self nxmoncar: 2];
//		neisum(0,AL,48);
//                }
//	    if (strcmp([[statNhood selectedCell] title],"general")==0) {
//		[self nxmoncar: 2];
//		gnlsum(0,AL,48);
//                }
//	    }
//	  }

//        if (drawArhi==YES) {
//      for (i0=0; i0<5; i0++) for (i1=0; i1<K3+1; i1++) sta[i0][i1]=0.0;
//      for (i1=0; i1<K3+1; i1++) sta[3][i1]=10.0;
//      stt=0.0;
//      allmo(&stt,sta);
//      ss=1;
//		}

//	if (drawTMatrix==YES) {
//	qqmat(umat,0,0);
//	}

        if (drawLine==YES) {
        for (j=0; j<8; j++) for (i=0; i<40; i++) videodot(j,i,arr1[i+40*j]);
	}

	/* now take each point and draw it */
	PSsetgray(NX_BLACK);
	i = [points count];
	while (i--) {
		aPoint = (NXPoint *)[points elementAt:i];
		drawCircle(aPoint->x, aPoint->y, radius);
	} 
	return self;
}


- clear:sender
/*
 * Clears the LCAUView by emptying its Storage object of all points
 * and then redisplaying the LCAUView.  This action is taken only if
 * the LCAUView's state requires it.
 */
{
	if (needsClearing) {
		[points empty];
		[self display];
		needsClearing = NO;
	}
	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LCAUView is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==7) {[self setDrawOrigin:0 :0]; return self;}
	if (drawview!=4&&drawview!=7) [self setDrawOrigin:-floor(width/2) : -floor(height/2)]; 
	return self;
}

- registerPoint:(NXPoint *)aPoint
/*
 * Adds a point to the list the LCAUView keeps in its Storage object. 
 */
{
	[points addElement:aPoint];
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LCAUView.  The LCAUView changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or mouse-
 * up events.  As it receives mouse-dragged events, the LCAUView updates the readOut
 * text Cell with the cursor's coordinates.  If the user releases the mouse
 * button while the cursor is over the LCAUView, the LCAUView registers the 
 * point and then sends a message to its delegate notifying it of the new 
 * point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;
   	char	buffer[100];

         double  x, y, ex, wy, eks, wye;
	 int k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];
 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
//		          k=nearest(ex,wy);

//       if (theEvent->data.mouse.click==3) {} else 
//       if (theEvent->data.mouse.click==2) {} else 
	{
	[self lockFocus];
//         PSsetinstance(YES);
	do {
// 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
//                ex=aPoint.x;
//                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
//				PSsetgray(NX_BLACK);
//				PSmoveto(ex+12.0,wy);
//				PSarc(ex, wy, 12.0, 0.0, 360.0);
//				PSstroke();
//				cntr[k][0]=ex;
//				cntr[k][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	    	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && [delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


	}
	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- setRadius:(float)aFloat
/*
 * Sets the value for the radius of the LCAUView's points.
 */
{
	radius = aFloat;
	return self;
}


- (float)radius
/*
 * Returns the value for the radius of the LCAUView's points.
 */
{
	return radius;
}

- read:(NXTypedStream *)stream
/*
 * Unarchives the LCAUView.  Initializes four of the LCAUView's instance variables
 * to the values stored in the stream. 
 */
{
	[super read:stream];
	delegate = NXReadObject(stream);
	NXReadTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LCAUView by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	NXWriteObjectReference(stream, delegate);
	NXWriteTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- plot:sender
/*
 * Responds to a plot: message by asking the LCAUView's delegate for a stream
 * containing the points to plot.  It then extracts number pairs from the 
 * stream and creates NXPoint structures with them.  For each structure it 
 * creates, the LCAUView sends itself a registerPoint: message to add the 
 * point to its list of points.  This simple parser ignores input it doesn't 
 * understand.
 */
{
	int	 	 c, sign, retval;
	float	 	 aNum;
	NXPoint	 	 aPoint;
	NXStream	*stream;
	BOOL		 processedLine = NO, gotFirst = NO, gotSecond = NO;
	
	if (delegate && [delegate respondsTo:@selector(PlotView:providePoints:)])
		[delegate PlotView:self providePoints:&stream];
	NXSeek(stream, 0, NX_FROMSTART);
	while ((c = NXGetc(stream)) != EOF){
		sign = 1;
		retval = getSeparator(stream);
		if (retval == 1) {
			c = NXGetc(stream);
		} else if (retval == -1) {
			break;
		}
		if (!NXIsDigit(c)) {
			if ((c == '-') && NXIsDigit(c = NXGetc(stream))){
					sign = -1;
			} else {
				while( (c != '\n') && (c != EOF)) {
					c = NXGetc(stream);
					processedLine = YES;
				}
			}
		}
		if (c == EOF)
			break;
		else if (processedLine) {
			processedLine = NO;
			continue;
		}
		aNum = getNumber(stream);
		if (!gotFirst) {
			aPoint.x = sign * aNum;
			gotFirst = YES;
		} else if (!gotSecond) {
			aPoint.y = sign * aNum;
			[self registerPoint:&aPoint];
			gotFirst = gotSecond = NO;
		} 
	}
	[self display];
	needsClearing = YES;
	return self;
}

int getSeparator(NXStream *stream)
/* 
 * Removes white space, commas, and plus signs from between 
 * number pairs.
 */
{
	int c, firstChar;
	
	NXUngetc(stream);
	c = firstChar = NXGetc(stream);
	while (NXIsSpace(c) || (c == ',') || (c == '+'))
		c = NXGetc(stream);
	/* 1 = ate something; 0 = ate nothing; -1 means EOF */
	if (c == firstChar)
		return 0;
	else if (c == EOF)
		return -1;
	NXUngetc(stream);
	return 1;
}

float getNumber(NXStream *stream)
/* 
 * Composes a floating point number from a string of number  
 * characters.
 */
{
	int c, i = 0;
	char temp[MAXNUMLENGTH];
	
	NXUngetc(stream);
	c = NXGetc(stream);
	while ((NXIsDigit(c) || (c == '.')) && (c != '\n') && (c != EOF)) {
		temp[i++] = c;
		c = NXGetc(stream);
	}
	NXUngetc(stream);
	temp[i] = 0;
	return (atof(temp));
}

@end

/* end LCAUView.m */
