
/* 
 * LiulGuph.m -- Implementation file for the LiulGuph class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, nor even that it has a use.
 *
 */

#import "LiulGuph.h"
#import "drawingFuncs.h"
#import "nxlcau42.h"
// #import "nxardn42.h"
#import "nxcycl42.h"
#import "nxrijn42.h"
#import <math.h> 
#import <objc/Storage.h>
#import <dpsclient/psops.h>
#import <dpsclient/wraps.h>
#import <stdlib.h>
#import <string.h>
 #include <stdio.h>
 #include <time.h>

int    drawCycle=NO;
int    drawPair=NO;
int    cnstRijn=NO;
int    drawRijn=NO;
int    justRijn=NO;
int    drawSubset=NO;
int    shortRijn=NO;

extern int    drawShort;
extern int    drawview;

int    rijnPerm;
int    rijnShift;
int    rijnGen;

extern int    probEIV;
extern int    probGenV;
extern int    probBlkV;


extern double dcntr[][2];
int    snod=0, cnod=0;
int    cydb=1;

extern double stt, sta[5][K3+1];

extern int    cc, dd;		/* radius of de Bruijn ring */

extern  parneih    amat;
extern  parneih    bmat;
extern  parneih    cmat;

extern twoparn    smat;
extern twoparn    tmat;
extern twoparn    umat;
extern twoparn    vmat;

extern NXColor colst[KK];

int    dbno=0;			/* node number in de Bruijn diagram 	*/

int    bdry, lbou, rbou;	/* boundary cells in cycle diagram	*/
int    cysh=XCY;		/* cycle marking option			*/
int    cyno=0;			/* node number in cycle diagram	    	*/

int    suno=0;			/* node number in subset diagram 	*/
int    sust=0;			/* designated state in subset diagram	*/
int    leenk[KK][DN];		/* links in de Bruijn diagram, by state	*/
int    liink[KK][SDN];		/* links in subset diagram, by state 	*/
int    sunanc[KK][SDN];		/* # ancestors in subset dgm, by state	*/
int    sudown[SDN];		/* depth of subset diagram nodes	*/
int    suhigh[SDN];		/* height of subset diagram nodes	*/
double scntr[SDN][2];		/* subset diagram coordinates		*/

int    prno=0;			/* node number in pair diagram		*/
int    prnd;			/* minimum pair separation		*/
int    prxd;			/* maximum pair separation		*/
int    prnl;			/* minimum loop length			*/
int    prxl;			/* maximum loop length			*/
int    ergset[PDN];		/* members of the ergodic set		*/
double pcntr[PDN][2];		/* pair diagram coordinates		*/

extern int    cylink[];		/* links in the cycle diagram		*/
extern int    cynanc[][21];	/* no of ancestors in the cycle diagram	*/
extern int    cyhanc[];		/* ancestor histogram for cycles	*/
extern int    cyhigh[];		/* level of cycle diagram nodes		*/
extern int    cymass[];		/* number of nodes in node's own tree	*/
extern int    cyroot[];		/* root for each node in cycle diagram	*/
extern int    cycomp[];		/* component for node in cycle diagram	*/
extern int    cyarry[];		/* scratch array for cycle diagrams	*/
extern int    xhigh, nhigh;	/* maximum height, minimum height  	*/
extern int    xroot, nroot;	/* maximum cycle, minimum cycle    	*/
extern int    cynum;		/* number of cycles			*/
extern double ccntr[][2];

extern double stt, sta[5][K3+1];

extern char   ascrule[KK][KK][KK][KK][KK];
extern int    cc, cy, dd;		/* radius of de Bruijn ring */
extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];

void   asctobin();
int    closeto(double x, double y);
void   edcyl(int *arry, int cc, int k, int l, int cn, int m);
void   edijn(int g, int s, int p, int r);
void   edPair(int l, int pc, int pa, int pl, int pv);
void   edSubset(int l, int pc, int pa, int pl, int pv);
void   finderset(int *e, twoparn *t);
void   geanc(int ance[][21], int *link, int cp);
void   gecyl(int *arry, int cy, int bl, int br, int l);
void   geroo(int *root, int *comp, int *link, int cp);
void   howdown(int *sud);
int    level (int n);
int    prnins(int i, twoparn *z);
int    prouts(int i, twoparn *z);
void   prxtrmd(int *min, int *max);
void   prxtrml(int *min, int *max);
int    putlevel(twoparn *zmat, twoparn *xmat, int n);
int    shflev(int g, int s);
void   shortevolve(int m, int n);
void   suanc();
void   upthere(int *sud);
void   wrru(char *c, char ru[KK][KK][KK][KK][KK]);


#define MAXNUMLENGTH 50
#define DEFAULTRADIUS 1.0

@implementation LiulGuph


/* --------------------------- T I M E  -  D A T E-------------------------- */

void telltime() {
/* 
    Turbo C Reference Guide Version 2.0 (1988)
    Borland International.
    Chapter2, The Turbo C library, pag. 226.
*/

  struct tm  *timeptr;
  time_t  secsnow;

/*  timezone = 8*60*60; */
   time(&secsnow);
   timeptr = localtime(&secsnow);
   printf("The date is %d-%d-19%02d\n",
          ((timeptr->tm_mon) + 1), timeptr->tm_mday,
           timeptr->tm_year);
   printf("Local time is %02d:%02d:%02d\n",
          timeptr->tm_hour, timeptr->tm_min,
         timeptr->tm_sec);
}

/* -------------------------------- R I J N -------------------------------- */

- rijn:sender
{int i;
  rijnGen=[sender selectedRow];
  rijnShift=4-(int)[sender selectedCol];
  [self rijnReset: self];
  [sender selectCellAt: rijnGen: 4-rijnShift];
  i=shflev(rijnGen,rijnShift);
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
  [[underDiagram cellAt: 0: i] performClick: self];
  [underDiagram selectCellAt: 0: i];
  [whichConstant setEmptySelectionEnabled: YES];
  [whichConstant selectCellAt: -1: 0];
  rijnPerm=[whichPermutation selectedRow];
  edijn(rijnGen,rijnShift,rijnPerm,![dbBranches state]);
  cnstRijn=NO;
return self;
}

- rijnConst:sender
{
  rijnGen=[sender selectedRow];
  rijnShift=[sender selectedCol];
  [self rijnReset: self];
  [sender selectCellAt: rijnGen: rijnShift];
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
  [[underDiagram cellAt: 0: rijnGen] performClick: self];
  [underDiagram selectCellAt: 0: rijnGen];
  [whichShift setEmptySelectionEnabled: YES];
  [whichShift selectCellAt: -1: 0];
  rijnPerm=[whichPermutation selectedRow];
  edijn('A'-'a'+rijnGen,rijnShift,rijnPerm,![dbBranches state]);
  cnstRijn=YES;
return self;
}

- rijnReset:sender 
{
  [whichShift setEmptySelectionEnabled: YES];
  [whichShift selectCellAt: -1: 0];
  [whichConstant setEmptySelectionEnabled: YES];
  [whichConstant selectCellAt: -1: 0];
  [underDiagram setEmptySelectionEnabled: YES];
  [[underDiagram selectedCell] setIntValue: 0];
return self;
}

/* dd = k^(2r)*k^(2*level) */
- rijnHowBig:sender
{
int    i;
double th, dt;
    switch([sender selectedCol]) {
      case 0:  dd=256; break;
//      case 1:  dd=6561; break;
      default: dd=256; break;}
  dt=6.28318/((double)(dd));
  for (i=0, th=0.5*dt; i<dd; i++, th+=dt) {
    dcntr[i][0]=200.0-180.0*sin(th);
    dcntr[i][1]=200.0-180.0*cos(th);
    }

return self;
}

/* load a panel for selecting the type of de Bruijn diagram */

- loadDiagramType:sender 
{char *ch;
  ch=[[sender selectedCell] title];
  if (strcmp(ch,"shift")==0)     [self loadSelectionPanel: shiftBox];
  if (strcmp(ch,"constant")==0)  [self loadSelectionPanel: constBox];
return self;
}

- loadSelectionPanel:rijnNewBox 
{NXRect bigRect, lilRect;
 id cv;
 cv=[rijnNewBox contentView];
printf("rijnNewBox title = %d\n",[[cv subviews] count]);
  [rijnBigBox getFrame: &bigRect];
  [rijnNewBox getFrame: &lilRect];
  [rijnLilBox setContentView: cv];
  lilRect.origin.x=
	bigRect.origin.x+(bigRect.size.width-lilRect.size.width)/2.0;
  lilRect.origin.y=
	bigRect.origin.y+(bigRect.size.height-lilRect.size.height)/2.0;
  [rijnLilBox setFrame: &lilRect];
  [rijnBigBox display];
  [rijnLilBox display];
return self;
}

- testRijn:sender 
{
  cydb=1;
  drawview=0;
  drawRijn=YES;
  [wholePanel smartPrintPSCode:self];
  drawRijn=NO;
	needsClearing = YES;
return self;
}

- rijnRanSam:sender
{
int  i;
  i='z';
  if (strcmp([[sender selectedCell] title],"random sample")==0) i='r';
  if (strcmp([[sender selectedCell] title],"selected node")==0) i='n';
  if (strcmp([[sender selectedCell] title],"scan links")==0)    i='i';
  if ([dbBranches state]) {[self clear: self]; return self;}
  if (cnstRijn) edshc(rijnGen,i); edshf(rijnGen,rijnShift,i);
  [evWindow makeKeyAndOrderFront: sender];
  [evButton performClick: sender];
return self;
}

- Zot:sender
{
  cydb=1;
    drawview=0;
    shortRijn=YES;
    [self display];
    shortRijn=NO;
return self;
}

- shewRijn:sender
{
  cydb=1;
    drawview=0;
    justRijn=YES;
    [self display];
    justRijn=NO;
return self;
}

- printRijn:sender
{
  cydb=1;
  drawview=0;
  shortRijn=YES;
  [self printPSCode:self];
  shortRijn=NO;
return self;
}

/* -------------------------------- C Y C L -------------------------------- */

- cySample:sender 
{int i, j, n;
  for (i=0; i<AL/cy; i++) {
    n=cyno;
    for (j=0; j<cy; j++) {arr1[cy*i+(cy-j-1)]=n%KK; n/=KK;}
    }
  [evWindow makeKeyAndOrderFront: sender];
  [evButton performClick: sender];
return self;
}

- prepareCycle:sender
{int i;
    switch([sender selectedCol]) {
     case 0:  cc=16; cy=2; break;
     case 1:  cc=64; cy=3; break;
     case 2:  cc=256; cy=4; break;
     case 3:  cc=1024; cy=5; break;
//     case 4:  cc=4096; cy=6; break;
     default: cc=64; cy=3; break;}
   [nodeNumber setStringValue: ""];

        if (strcmp([[cyBou selectedCell] title],"cycle")==0) bdry=0;
        if (strcmp([[cyBou selectedCell] title],"fixed")==0) bdry=1;
	lbou=[leftBoundary selectedRow];
	rbou=[rightBoundary selectedRow];
        gecyl(cylink,cy,lbou,rbou,bdry);
	geanc(cynanc,cylink,cc);
	geroo(cyroot,cycomp,cylink,cc);
	hiroo(cymass,cyroot,cc);
	gehei(cyhigh,cyroot,cylink,cc);
	
	[[cyTriv1 cellAt: 0: 0] setIntValue: xhigh];
	[[cyTriv1 cellAt: 1: 0] setIntValue: nhigh];
	[[cyTriv1 cellAt: 2: 0] setIntValue: cynum];
	[[cyTriv1 cellAt: 3: 0] setIntValue: xroot];
	[[cyTriv1 cellAt: 4: 0] setIntValue: nroot];

  for (i=0; i<cc; i++) {
    ccntr[i][0]=(double)(rand()%500);
    ccntr[i][1]=(double)(rand()%500);
    }
  [self showCycle: self];
return self;
}

- makeTree:sender 
{int j;
  j=cyroot[cyno];
  nicetree(j,ccntr[j][0],ccntr[j][1],40.0,1.0,0.3);
  [self showCycle: self];
return self;
}

- redrawCycle:sender
{int i;
   i=[nodeNumber intValue];
   if (strcmp([[cyNode selectedCell] title],"self")==0) cysh=i;
   if (strcmp([[cyNode selectedCell] title],"next")==0) cysh=cylink[i];
   if (strcmp([[cyNode selectedCell] title],"none")==0) cysh=XCY;
   if (strcmp([[cyNode selectedCell] title],"root")==0) cysh=cyroot[i];
   [nodeNumber setIntValue: cysh];
   [self setCyTriv];
   [self showCycle: self];
return self;
}

- setCyTriv
{int i, j, k, m;
  [[cyTriv2 cellAt: 0: 0] setIntValue: cyno];
  [[cyTriv2 cellAt: 1: 0] setIntValue: cyhigh[cyno]];
  j=cynanc[cyno][0];
  if (cyroot[cyno]==cyno) j--;
  [[cyTriv2 cellAt: 2: 0] setIntValue: j];
  [[cyTriv2 cellAt: 3: 0] setIntValue: cymass[cyroot[cyno]]];
  i=k=cyroot[cyno]; j=m=0;
  do {i=cylink[i]; j++; m+=cymass[i];} while (i!=k);
  [[cyTriv2 cellAt: 4: 0] setIntValue: j];
  [[cyTriv2 cellAt: 5: 0] setIntValue: m];
return self;
}

- showCycle:sender
{
  cydb=0;
  drawview=0;
  drawCycle=YES;
  [self display];
  drawCycle=NO;
return self;
}

- printCycle:sender
{
  cydb=0;
  drawview=0;
  drawCycle=YES;
  [wholePanel smartPrintPSCode:self];
  drawCycle=NO;
return self;
}

/* -------------------------------- P A I R -------------------------------- */

- showPair:sender
{
int    i, j, k;

asctobin();
// zmat(&amat);  djmat(&amat,0);
// zmat(&bmat);  djmat(&bmat,1);
// zmat(&cmat);  djmat(&cmat,2);
// zzmat(&tmat); tensq(&tmat,&amat,&bmat,&cmat);
// smat=umat=tmat; 
//   i=2; do {
//     mmmat(&vmat,&umat,&tmat);
//     k=putlevel(&smat,&vmat,i);
//     umat=vmat;
//     i++;
// printf("running level %3d\n",k);
//     } while (k!=0);
//  for (i=0; i<K3; i++) for (j=0; j<K3; j++) 
//	[[prTriv cellAt: i: j] setIntValue: smat.two[i][j]];
//   prxtrmd(&prnd,&prxd);
//   [prTriv1 setIntValue: prnd at: 2];
//   [prTriv1 setIntValue: prxd at: 3];
//   prxtrml(&prnl,&prxl);
//   [prTriv1 setIntValue: prnl at: 0];
//   [prTriv1 setIntValue: prxl at: 1];
// 
//   umat=tmat;
//   for (i=0; i<PDN; i++) ergset[i]=1;
//   for (i=0; i<5; i++) finderset(ergset,&umat);
// 
//   for (i=0; i<K4; i++) for (j=0; j<K4; j++) {
//     pcntr[i+K4*j][0]=(double)(40+60*i);
//     pcntr[i+K4*j][1]=(double)(40+60*j);
//     }
//   [self redrawPair: self];
return self;
}

- redrawPair:sender
{int i;
//   i=[nodeNumber intValue];
//   if (strcmp([[cyNode selectedCell] title],"self")==0) cysh=i;
//   if (strcmp([[cyNode selectedCell] title],"next")==0) cysh=cylink[i];
//   if (strcmp([[cyNode selectedCell] title],"none")==0) cysh=XCY;
//   if (strcmp([[cyNode selectedCell] title],"root")==0) cysh=cyroot[i];
     [nodeNumber setIntValue: prno];
//   [self setprTriv2];
  cydb=2;
  drawview=0;
  drawPair=YES;
  [self display];
  drawPair=NO;
return self;
}

- printPair:sender
{
  cydb=2;
  drawview=0;
  drawPair=YES;
  [wholePanel smartPrintPSCode:self];
  drawPair=NO;
return self;
}

int putlevel(zmat,xmat,n) twoparn *zmat, *xmat; int n; {int i, k;
k=0;
for (i=0; i<K8*K8; i++) 
  if (zmat->one[i]==0 && xmat->one[i]!=0) {zmat->one[i]=n; k=1;}
return k;
}

void edPair(l,pc,pa,pl,pv) int l, pc, pa, pl, pv; {
int    i, j, k, m;
char   s[10];
double x, y, ex, wy, eks, wye, dx, dy, r, t;

  m=0;
  r=10.3;
  for (i=0; i<PDN; i++) {
    if (ergset[i]==0) continue; 
    for (j=0; j<PDN; j++) {
     	if (ergset[j]==0) continue; 
//	if (tmat.two[i][j]==0) continue;
	m++;
	ex=pcntr[i][0];
	wy=pcntr[i][1];
	PSmoveto(ex,wy);
	x=pcntr[j][0];
	y=pcntr[j][1];
	dx=x-ex;
	dy=y-wy;
	t=atan2(dy,dx);
	eks=x-r*cos(t);
	wye=y-r*sin(t);
	if (pa==YES) {
	  PSlineto(eks,wye);
	  PSlineto(eks-0.1*dx+0.05*dy,wye-0.1*dy-0.05*dx);
	  PSlineto(eks-0.1*dx-0.05*dy,wye-0.1*dy+0.05*dx);
	  PSlineto(eks,wye);
	  }
	if (pc==YES) {
	  PSmoveto(x+10.3,y);
	  PSarc(x, y, 10.3, 0.0, 360.0);
	  PSmoveto(ex+10.3,wy);
	  PSarc(ex, wy, 10.3, 0.0, 360.0);
	  }
	}

   if (pl==YES) {
   ex=pcntr[i][0];
   wy=pcntr[i][1];
   PSmoveto(ex-10.0,wy+5.0);
	sprintf(s,"(%2d)",i);
//	sprintf(s,"(%1d%1d,%1d%1d)",i0,i1,i2,i3);
   PSshow(s);
   }
  }
//	printf("total links = %5d\n",m);
}

/* find index of nearest center to x, y (cycles) */
int nearto(x,y) double x, y; {int i, k; double ex, wy, r, p;
k=0; p=500000.0;
for (i=0; i<PDN; i++) {
  ex=x-pcntr[i][0];
  wy=y-pcntr[i][1];
  r=ex*ex+wy*wy;
  if (r<p) {p=r; k=i;}
  }
return k;
}

/* calculate number of incoming links for pair diagram nodes */
int prnins(i,z) int i; twoparn *z; {int j, k;
for (k=0, j=0; j<PDN; j++) if (z->two[j][i]!=0) k++;
return k;
}

/* calculate number of incoming links for pair diagram nodes */
int prouts(i,z) int i; twoparn *z; {int j, k;
for (k=0, j=0; j<PDN; j++) if (z->two[i][j]!=0) k++;
return k;
}

/* if there are no ins to i, make link(i,j)=0 for all j */
void finderset(e,t) int *e; twoparn *t; {int i, j; twoparn z;
z=*t;
for (i=0; i<PDN; i++) if (prnins(i,&z)==0) {
  e[i]=0;
  for (j=0; j<PDN; j++) z.two[i][j]=0;
  }
for (i=0; i<PDN; i++) if (prouts(i,&z)==0) {
  e[i]=0;
  for (j=0; j<PDN; j++) z.two[j][i]=0;
  }
*t=z;
}

/* find extremal distances in the pair distance matrix */
void prxtrmd(min, max) int *min, *max; {int i, n, x, s;
x=0; n=K8*K8;
// for (i=0; i<K8*K8; i++) {s=smat.one[i]; if (s<n) n=s; if (s>x) x=s;}
*min=n; *max=x;
}

/* find extremal loops in the pair distance matrix */
void prxtrml(min, max) int *min, *max; {int i, n, x, s;
x=0; n=K8*K8;
// for (i=0; i<K8; i++) {s=smat.two[i][i]; if (s<n) n=s; if (s>x) x=s;}
*min=n; *max=x;
}

/* -----------------------------  S U B S E T  ---------------------------- */

- prepareSubset:sender
{
int    i, j, k, s, p;

asctobin();
// zmat(&amat);  djmat(&amat,0);
// zmat(&bmat);  djmat(&bmat,1);

/* generate the de Bruijn diagram's out-linkages */
for (i=0; i<DN; i++) {
//   for (s=0, p=1, j=0; j<DN; j++, p*=2) if (amat.two[i][j]==1) s|=p;
  leenk[0][i]=s;
//   for (s=0, p=1, j=0; j<DN; j++, p*=2) if (bmat.two[i][j]==1) s|=p;
  leenk[1][i]=s;
  }

// for (i=0; i<DN; i++) printf("%3d ",leenk[0][i]);
// printf("\n");
// for (i=0; i<DN; i++) printf("%3d ",leenk[1][i]);
// printf("\n");

/* generate the subset diagram's out-linkages */
for (k=0; k<KK; k++) for (i=0; i<SDN; i++) {
  for (p=i, s=0, j=0; j<DN; p/=2, j++) if (p%2==1) s|=leenk[k][j];
  liink[k][i]=s;
  }
  
  suanc();
  howdown(sudown);
  [suTriv1 setIntValue: sudown[0]];
  [[suTriv2 cellAt:0 :0] setIntValue: sudown[  1]];
  [[suTriv2 cellAt:0 :1] setIntValue: sudown[  2]];
  [[suTriv2 cellAt:0 :2] setIntValue: sudown[  4]];
  [[suTriv2 cellAt:0 :3] setIntValue: sudown[  8]];
  [[suTriv2 cellAt:0 :4] setIntValue: sudown[ 16]];
  [[suTriv2 cellAt:0 :5] setIntValue: sudown[ 32]];
  [[suTriv2 cellAt:0 :6] setIntValue: sudown[ 64]];
  [[suTriv2 cellAt:0 :7] setIntValue: sudown[128]];
  upthere(suhigh);
printf("suhigh[%2d]= %3d\n",SDN-1,suhigh[SDN-1]);
  scntr[0][0]=150.0;
  scntr[0][1]=470.0;
  for (i=1; i<SDN-1; i++) {
    scntr[i][0]=(double)(50+random()%200);
    scntr[i][1]=500.0-(double)(15+60*level(i))+(double)(random()%12)-15.0;
    }
  scntr[SDN-1][0]=150.0;
  scntr[SDN-1][1]= 30.0;

  [self showSubset: self];
return self;
}

- showSubset:sender
{
  cydb=3;
  drawview=0;
  drawSubset=YES;
  [self display];
  drawSubset=NO;
return self;
}

- printSubset:sender
{
  cydb=3;
  drawview=0;
  drawSubset=YES;
  [wholePanel smartPrintPSCode:self];
  drawSubset=NO;
return self;
}

/* draw linkages &c in the subset diagram */
/*  l = state/color of link		  */
/* pc = draw circle?			  */
/* pa = draw arrow?			  */
/* pl = draw line?			  */
void edSubset(l,pc,pa,pl,pv) int l, pc, pa, pl, pv; {
int    i, j;
char   s[10];
double x, y, ex, wy, eks, wye, dx, dy, r, t;
  r=10.3;
  for (i=0; i<SDN; i++) {
	if (!pv && 
	    i != SDN-1 &&
	    (sunanc[0][i] == 0) &&
	    (sunanc[1][i] == 0)
	    ) continue;
	ex=scntr[i][0];
	wy=scntr[i][1];
	PSmoveto(ex,wy);
	j=liink[l][i];
	x=scntr[j][0];
	y=scntr[j][1];
	dx=x-ex;
	dy=y-wy;
	t=atan2(dy,dx);
	eks=x-r*cos(t);
	wye=y-r*sin(t);
	if (pa==YES) {
	  PSlineto(eks,wye);
	  PSlineto(eks-0.1*dx+0.05*dy,wye-0.1*dy-0.05*dx);
	  PSlineto(eks-0.1*dx-0.05*dy,wye-0.1*dy+0.05*dx);
	  PSlineto(eks,wye);
	  }
	if (pc==YES) {
	  PSmoveto(x+10.3,y);
	  PSarc(x, y, 10.3, 0.0, 360.0);
	  PSmoveto(ex+10.3,wy);
	  PSarc(ex, wy, 10.3, 0.0, 360.0);
	  }

   if (pl==YES) {
     ex=scntr[i][0];
     wy=scntr[i][1];
     PSmoveto(ex-10.0,wy+5.0);
     sprintf(s,"%2d",i);
     PSshow(s);
     }
   }
}

/* calculate subset level */
int level (n) int n; {
int i, s;
s=0;
i=n;
while (i!=0) {s+=i%2; i/=2;}
return s;
}

/* calculate number of in-links for subset diagram nodes */
/* and place the results in the array sunanc		 */
void suanc() {
int i, j;
for (j=0; j<KK; j++) for (i=0; i<SDN; i++) sunanc[j][i]=0;
for (j=0; j<KK; j++) for (i=0; i<SDN; i++) sunanc[j][liink[j][i]]++;
}

/* list shortest path lengths from maximum to given node */
void howdown(sud) int *sud; {
int i, j, k, p;
  for (i=0; i<SDN; i++) sud[i]=SDN;
  sud[SDN-1]=0;
  for (j=0; j<SDN; j++) { 
    for (p=0, i=0; i<SDN; i++) for (k=0; k<KK; k++) 
	if (sud[liink[k][i]]>sud[i]+1) {sud[liink[k][i]]=sud[i]+1; p++;}
    if (p==0) break;
    }
}

/* list shortest path lengths from given node to minimum */
void upthere(sud) int *sud; {
int i, j, k, p;
  for (i=0; i<SDN; i++) sud[i]=SDN;
  sud[0]=0;
  for (j=0; j<SDN; j++) { 
    for (p=0, i=0; i<SDN; i++) for (k=0; k<KK; k++) 
	if (sud[i]>sud[liink[k][i]]+1) {sud[i]=sud[liink[k][i]]+1; p++;}
    if (p==0) break;
    }
}

/* find index of nearest center to x, y (subset) */
int closeto(x,y) double x, y; {int i, k; double ex, wy, r, p;
k=0; p=500000.0;
for (i=0; i<SDN; i++) {
  ex=x-scntr[i][0];
  wy=y-scntr[i][1];
  r=ex*ex+wy*wy;
  if (r<p) {p=r; k=i;}
  }
return k;
}

/* - - - - - - - - - - - - -    L I U L G U P H   - - - - - - - - - - - - - */


- initFrame:(const NXRect *)frameRect
/*
 * Initializes the new LiulGuph object.  First, an initFrame: message is sent 
 * to super to initialize LiulGuph as a View.  Next, the LiulGuph sets its own 
 * state -- that it is opaque and that the origin of its coordinate system lies 
 * in the center of its area.  It then creates and initializes its associated 
 * objects, a Storage object, an NXCursor, and a Cell.  Finally, it loads into 
 * the Window Server some PostScript procedures that it will use in drawing 
 * itself. 
 */
{
	NXPoint	spot;
	
	[super initFrame:frameRect];
/*	[self translate:floor(frame.size.width/2) :floor(frame.size.height/2)]; */
	[self setOpaque:YES];
	[self setRadius:DEFAULTRADIUS];
	points = [[Storage alloc] 
		initCount:0 elementSize:sizeof(NXPoint) description:"{ff}"];
	crossCursor = [NXCursor 
		newFromImage:[NXImage newFromSection:"cross.tiff"]];
	spot.x = spot.y = 7.0;
	[crossCursor setHotSpot:&spot];
	/* 
	 * Normally, the next two message expressions would be combined, as:
	 * 		readOut = [[Cell alloc] initTextCell:""];
	 * but are here separated for clarity.
	 */
	readOut = [Cell alloc];
	[readOut initTextCell:"pointies"];
	[readOut setBezeled:YES];
	loadPSProcedures();

  PSsetgray(NX_BLACK);
  PSselectfont("Times-Roman",16.0);

  [self setFlipped: YES];

	return self;

}


- setDelegate:anObject
/*
 * Sets the LiulGuph's delegate instance variable to the supplied object.
 */
{
	delegate = anObject;
	return self;
}


- drawSelf:(const NXRect *)rects :(int)rectCount
/*
 * Draws the LiulGuph's background and axes.  If there are any points,
 * these are drawn too.
 *
 * (Note:  For simplicity, although LiulGuph only repaints the background 
 * of the update region, it redraws the entire axes.  For better performance, 
 * only those parts of the axes that fall within the update region should 
 * be redrawn.)   
 */
{
        char             c[WNML], timday[30];
	unsigned int	 i, j, k;
        double           p, q, s, dp, pee, cue;
  struct tm  *timeptr;
  time_t  secsnow;
	NXPoint		 *aPoint;
	NXRect		 plotRect;

int     i0, i1, ss;
	
	if (rects == NULL) return self;

	/* 
	 * If we're printing, we need to load drawing procedures to the 
	 * printing context.  This simple test is OK for a View that prints a 
	 * single page.  If there were multiple pages, the procedures would be 
	 * loaded multiple times.  Although this is inefficient, it causes no 
	 * error.  Views that print multiple pages should load procedures such 
	 * as these in an endPrologue method (see the View spec sheet). 
	 */
	if (NXDrawingStatus != NX_DRAWING) 
		loadPSProcedures();

	/* paint visible area white then draw axes */
	PSsetgray(NX_WHITE);
	NXRectFill(&rects[0]);
	PSsetgray(NX_DKGRAY);

// drawAxes(bounds.origin.x, bounds.origin.y, bounds.size.width, bounds.size.height);

   time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(timday,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);

/* for the cycle diagram --- - - - - - - - - - - - - - - - - - - - - - - - - */

        if (drawCycle==YES) {
  	[[Font newFont: "Courier" size: 10.0 matrix:NX_FLIPPEDMATRIX] set];
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
	PSsetgray(NX_BLACK); 
	edcyl(cylink,
	      cc,
	      [labelStyle selectedRow],
	      cysh,
	      cyno,
	      [treeShow selectedRow]);
	cysh=XCY;
   [timeDate setStringValue: timday];
		}

/* for the pair diagram - - - - - - - - - - - - - - - - - - - - - - - - - - */

        if (drawPair==YES) {
  	[[Font newFont: "Courier" size: 10.0 matrix:NX_FLIPPEDMATRIX] set];
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
		PSsetgray(NX_BLACK); 
		edPair(0,YES,YES,YES,[treeShow state]);
		PSstroke();
   [timeDate setStringValue: timday];
		}

/* for the subset diagram -- - - - - - - - - - - - - - - - - - - - - - - - - */

        if (drawSubset==YES) {
  	[[Font newFont: "Courier" size: 10.0 matrix:NX_FLIPPEDMATRIX] set];
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];

	for (i=0; i<KK; i++) {
	    if ([[linkAge cellAt: i: 0] state]) {
		PSsetlinewidth(1.0);
		NXSetColor(colst[i]);
//		PSsetgray(NX_LTGRAY); 
		edSubset(i,NO,YES,NO,[treeShow state]);
		PSstroke();
		}
	    }
		PSsetlinewidth(0.0);
		PSsetgray(NX_BLACK); 
		edSubset(0,YES,NO,YES,[treeShow state]);
		PSstroke();
   [timeDate setStringValue: timday];
		}


/* for the de Bruijn  diagram --- - - - - - - - - - - - - - - - - - - - - */

        if (drawRijn==YES) {
		PSsetgray(NX_BLACK); 
		ijn(dd,KK,1); 
		PSstroke();
		[evButton performClick: self];
   [timeDate setStringValue: timday];
		}

        if (justRijn==YES) {
		PSsetgray(NX_BLACK); 
		ijn(dd,KK,1); 
		PSstroke();
   [timeDate setStringValue: timday];
		}

        if (shortRijn==YES) {
  	[[Font newFont: "Courier" size: 20.0 matrix:NX_FLIPPEDMATRIX] set];
   wrru(c,ascrule);
   [ruleNumber setStringValue: c];
   PSmoveto(290.0,14.0);
   PSshow(c);
   PSmoveto(12.0,14.0);
  	[[Font newFont: "Courier" size: 12.0 matrix:NX_FLIPPEDMATRIX] set];
   if (cnstRijn) sprintf(c,"evolving to %1d in %1d gen",rijnShift,rijnGen+1); 
	else {if (rijnPerm==0) 
	  sprintf(c,"shift %1d in %1d gen",-rijnShift,rijnGen+1);
	  else 
sprintf(c,"shift %1d in %1d gen perm %d",-rijnShift,rijnGen+1,rijnPerm);}
   PSshow(c);
  	[[Font newFont: "Courier" size: 10.0 matrix:NX_FLIPPEDMATRIX] set];
		PSsetgray(NX_BLACK); 
		if (cnstRijn) edcst(rijnGen); else edshg(rijnGen,rijnShift);
		PSstroke();

   [timeDate setStringValue: timday];

		}



	/* now take each point and draw it */
	PSsetgray(NX_BLACK);
	i = [points count];
	while (i--) {
		aPoint = (NXPoint *)[points elementAt:i];
		drawCircle(aPoint->x, aPoint->y, radius);
	} 
	return self;
}

- clear:sender
/*
 * Clears the LiulGuph by emptying its Storage object of all points
 * and then redisplaying the LiulGuph.  This action is taken only if
 * the LiulGuph's state requires it.
 */
{
	if (needsClearing) {
		[points empty];
		[self display];
		needsClearing = NO;
	}
	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
/*
 * Ensures that whenever the LiulGuph is resized, the origin of its 
 * coordinate system is repositioned to the center of its area.
 */
{
//	  [self setFlipped: YES];
	[super sizeTo:width :height];
	if (drawview==4||drawview==7) 
		{[self setDrawOrigin:0 :0]; return self;}
	if (drawview!=4) 
		[self setDrawOrigin:-floor(width/2) : -floor(height/2)]; 
	return self;
}

- registerPoint:(NXPoint *)aPoint
/*
 * Adds a point to the list the LiulGuph keeps in its Storage object. 
 */
{
	[points addElement:aPoint];
	return self;
}

- mouseDown:(NXEvent *) theEvent
/*
 * Responds to a message the system sends whenever the user presses the mouse
 * button when the cursor is over the LiulGuph.  The LiulGuph changes the 
 * cursor to a cross-hairs image and then starts asking for mouse-dragged or 
 * mouse-up events.  As it receives mouse-dragged events, the LiulGuph updates 
 * the readOut text Cell with the cursor's coordinates.  If the user releases 
 * the mouse button while the cursor is over the LiulGuph, the LiulGuph 
 * registers the point and then sends a message to its delegate notifying it of 
 * the new point.
 */
{
	int	looping = YES, oldMask;
	NXPoint	aPoint;
	NXRect	plotRect, cellRect;
   	char	buffer[100];

         double  x, y, ex, wy, eks, wye;
	 int i, j, k;

	[crossCursor set];
   	[self getBounds:&plotRect];
 	NXSetRect(&cellRect, plotRect.origin.x, plotRect.origin.y, 100.0, 20.0);

	oldMask = [window addToEventMask:NX_MOUSEDRAGGEDMASK];

/* for the cycle diagram --- - - - - - - - - - - - - - - - - - - - - - - - - */

  if (cydb==0) {

 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				cyno=nearby(ex,wy);
				[nodeNumber setIntValue: cyno];
				[self setCyTriv];

       if (theEvent->data.mouse.click==3) {} else 
       if (theEvent->data.mouse.click==2) {
	 for (i=0, j=1; i<cy; i++) j*=KK;
	   switch ([[moveWhich selectedCell] tag]) {
	   case 0: ingather(ccntr,cylink,cyno,j); break;
	   case 1: ingather(ccntr,cylink,cylink[cyno],j);
		   ccntr[cyno][0]=ex;
		   ccntr[cyno][1]=wy;
		   break;
	   case 2: outgather(ccntr,cylink,cyno); break;
	   case 3: outgather(ccntr,cylink,cylink[cyno]);
		   ccntr[cyno][0]=ex;
		   ccntr[cyno][1]=wy;
		   break;
	   case 4: ingather(ccntr,cylink,cyno,j);
		   outgather(ccntr,cylink,cyno);
		   break;
	   default: break;}
   drawCycle=YES;
   [self display];
   drawCycle=NO;

		} else {
	[self lockFocus];
         PSsetinstance(YES);
	do {
 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
                ex=aPoint.x;
                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
				PSmoveto(ex+12.0,wy);
				PSarc(ex, wy, 12.0, 0.0, 360.0);
				PSstroke();
				ccntr[cyno][0]=ex;
				ccntr[cyno][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && 
		[delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView: 
					self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && 
	(theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


   drawCycle=YES;
   [self display];
   drawCycle=NO;


	}
  }

/* for the de Bruijn  diagram --- - - - - - - - - - - - - - - - - - - - - */

  if (cydb==1) {

 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				dbno=nearest(ex,wy);
				[nodeNumber setIntValue: dbno];

       if (theEvent->data.mouse.click==3) {} else 
       if (theEvent->data.mouse.click==2) {
		eks=0.05*(ex-200.0);
		wye=0.05*(wy-200.0);
				dcntr[dbno][0]=ex-eks;
				dcntr[dbno][1]=wy-wye;
		} else {
	[self lockFocus];
         PSsetinstance(YES);
	do {
 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
                ex=aPoint.x;
                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
				PSmoveto(ex+12.0,wy);
				PSarc(ex, wy, 12.0, 0.0, 360.0);
				PSstroke();
				dcntr[dbno][0]=ex;
				dcntr[dbno][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	    	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && [delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


   shortRijn=YES;
//   [window display];
   [self display];
   shortRijn=NO;


	}

  }

/* for the pair diagram  - - - - - - - - - - - - - - - - - - - - - - - - - - */

  if (cydb==2) {

 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				prno=nearto(ex,wy);
				[nodeNumber setIntValue: prno];

       if (theEvent->data.mouse.click==3) {} else 
       if (theEvent->data.mouse.click==2) {} else {
	[self lockFocus];
         PSsetinstance(YES);
	do {
 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
                ex=aPoint.x;
                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
				PSmoveto(ex+12.0,wy);
				PSarc(ex, wy, 12.0, 0.0, 360.0);
				PSstroke();
				pcntr[prno][0]=ex;
				pcntr[prno][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	    	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && [delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


   drawPair=YES;
   [self display];
   drawPair=NO;


	}
  }

/* for the subset diagram - - - - - - - - - - - - - - - - - - - - - - - - - */

  if (cydb==3) {

 				[window setDocEdited:YES];
		                aPoint = theEvent->location;
		                [self convertPoint:&aPoint fromView:nil];
                                ex=aPoint.x;
                                wy=aPoint.y;
				suno=closeto(ex,wy);
				[nodeNumber setIntValue: suno];

       if (theEvent->data.mouse.click==3) {} else 
       if (theEvent->data.mouse.click==2) {for (i=0; i<KK; i++) {
  if ([[linkAge cellAt: i: 0] state]) switch ([[moveWhich selectedCell] tag]) {
	case 0: ingather(scntr,liink[i],suno,SDN); break;
	case 1: ingather(scntr,liink[i],liink[i][suno],SDN); break;
	case 2: outgather(scntr,liink[i],suno); break;
	case 3: outgather(scntr,liink[i],liink[i][suno]); break;
	case 4: ingather(scntr,liink[i],suno,SDN); 
		outgather(scntr,liink[i],suno); break;
	default: break;}
		}
   drawSubset=YES;
   [self display];
   drawSubset=NO;

		} else {
	[self lockFocus];
         PSsetinstance(YES);
	do {
 		PSnewinstance();
		aPoint = theEvent->location;
		[self convertPoint:&aPoint fromView:nil];
                ex=aPoint.x;
                wy=aPoint.y;
		sprintf(buffer, "(%d, %d)", (int)aPoint.x, (int)aPoint.y); 
  		[readOut setStringValue:buffer];
  		[readOut drawInside:&cellRect inView:self];
				PSsetgray(NX_BLACK);
				PSmoveto(ex+12.0,wy);
				PSarc(ex, wy, 12.0, 0.0, 360.0);
				PSstroke();
				scntr[suno][0]=ex;
				scntr[suno][1]=wy;
		[window flushWindow];
		if (theEvent->type == NX_MOUSEUP) {
	    	/* on mouse-up, register point, inform delegate, and clean up state */
			[readOut setStringValue:""];
  			[readOut drawInside:&cellRect inView:self];
			[window flushWindow];
			if (NXPointInRect(&aPoint, &plotRect)) {
				PSsetgray(NX_BLACK);
				drawCircle(aPoint.x, aPoint.y, radius);
				[window flushWindow];
				[self registerPoint:&aPoint];
				needsClearing = YES;
				if (delegate && [delegate respondsTo:@selector(PlotView:pointDidChange:)])
					[delegate PlotView:self pointDidChange:&aPoint];
			}
			looping = NO;
		}	
   	} while (looping && (theEvent=[NXApp getNextEvent:NX_MOUSEUPMASK|NX_MOUSEDRAGGEDMASK]));
	[self unlockFocus];


   drawSubset=YES;
   [self display];
   drawSubset=NO;


	}
  }

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ 

	[window setEventMask:oldMask];
	[NXArrow set];
	return self;
}

- setRadius:(float)aFloat
/*
 * Sets the value for the radius of the LiulGuph's points.
 */
{
	radius = aFloat;
	return self;
}


- (float)radius
/*
 * Returns the value for the radius of the LiulGuph's points.
 */
{
	return radius;
}


- read:(NXTypedStream *)stream
/*
 * Unarchives the LiulGuph.  Initializes four of the LiulGuph's instance 
 * variables to the values stored in the stream. 
 */
{
	[super read:stream];
	delegate = NXReadObject(stream);
	NXReadTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- write:(NXTypedStream *)stream
/*
 * Archives the LiulGuph by writing its important instance variables to the 
 * stream. 
 */
{
	[super write:stream];
	NXWriteObjectReference(stream, delegate);
	NXWriteTypes(stream, "@@@f", &points, &crossCursor, &readOut, &radius);
	return self;
}

- awake
/*
 * Finishes initializing a LiulGuph that has just been unarchived (see the 
 * read: method).
 */
{
	loadPSProcedures();
	return [super awake];
}


- (const char *)inspectorName
{
    return "LiulGuphInspector";
}

- plot:sender
/*
 * Responds to a plot: message by asking the LiulGuph's delegate for a stream
 * containing the points to plot.  It then extracts number pairs from the 
 * stream and creates NXPoint structures with them.  For each structure it 
 * creates, the LiulGuph sends itself a registerPoint: message to add the 
 * point to its list of points.  This simple parser ignores input it doesn't 
 * understand.
 */
{
	int	 	 c, sign, retval;
	float	 	 aNum;
	NXPoint	 	 aPoint;
	NXStream	*stream;
	BOOL		 processedLine = NO, gotFirst = NO, gotSecond = NO;
	
	if (delegate && [delegate respondsTo:@selector(PlotView:providePoints:)])
		[delegate PlotView:self providePoints:&stream];
	NXSeek(stream, 0, NX_FROMSTART);
	while ((c = NXGetc(stream)) != EOF){
		sign = 1;
		retval = getSeparator(stream);
		if (retval == 1) {
			c = NXGetc(stream);
		} else if (retval == -1) {
			break;
		}
		if (!NXIsDigit(c)) {
			if ((c == '-') && NXIsDigit(c = NXGetc(stream))){
					sign = -1;
			} else {
				while( (c != '\n') && (c != EOF)) {
					c = NXGetc(stream);
					processedLine = YES;
				}
			}
		}
		if (c == EOF)
			break;
		else if (processedLine) {
			processedLine = NO;
			continue;
		}
		aNum = getNumber(stream);
		if (!gotFirst) {
			aPoint.x = sign * aNum;
			gotFirst = YES;
		} else if (!gotSecond) {
			aPoint.y = sign * aNum;
			[self registerPoint:&aPoint];
			gotFirst = gotSecond = NO;
		} 
	}
	[self display];
	needsClearing = YES;
	return self;
}



@end

/* end LiulGuph.m */
