
/* revisado 25 agosto 1995 */
#import "RulePanel.h"
#import "nxlcau42.h"
#import <string.h>
#import <time.h>
#import "rec.h"

extern char arr1[AL], arr2[AL], arr3[AL];
extern int binrule[KK][KK][KK][KK][KK];
extern char ascrule[KK][KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK][KK];
extern char gf3rule[13];	/* coefficients of GF3 rule	*/
extern char ttrule[TS];	/* totalistic rule		*/
extern char tarule[TS];
extern char strule[KK][SS];	/* semitotalistic rule		*/
extern char sarule[KK][SS];
extern char *iquon(int k);
extern char *texth(int k);

extern NXColor colst [KK];

extern struct fptbl dtbl[];
extern Inst   xprg[][XLEN];
extern char   idef[][30];

typedef union birular {int one[KK*KK*KK*KK*KK]; int three[KK][KK][KK][KK][KK];} birular;

int     allperm(char wn[][10], char ii[][KK][KK][KK][KK][KK], char ru[KK][KK][KK][KK][KK]);
void    asctobin();	/*nxlcau42.c*/
void	asczero();
void	auxzero();
void    bincopy(birular *rz, birular rx);
void    binprint(birular rz);
void    binprod(birular *rz, birular rx, birular ry);
void    binsum(birular *rz, birular rx, birular ry);
void    bintoasc();
void   chrucopy(char ii[KK][KK][KK][KK][KK],char jj[KK][KK][KK][KK][KK],int c);
int     cyy(int i);
int     fli(int i);
	void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();		/*nxlcau42.c*/
int     isstot();
//int     longwolftoasc(char *c);
//	void    oxtoasc(char *r);
//	int     permut(int k, int n);
void    putionj(int i, int j);
int     ran2of3(int a, int b, int c);
int     ran3of3(int a, int b, int c, int d);
void    ranblin(double p0, double p1, double p2, double p3);
void    ranvachrul(char *c);
int     rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
int     rec_x(Inst rprg);
//void	runowows(char x[2][2][2], int n);
void    rule42();
void	sttoasc();
void    stzero();
void	totoasc();	/*nxlcau42.c*/
int     totonu(int i);	/*nxlcau42.c*/
void    ttzero();
//int     vecperm(int ii[KK], int n);
//int     wolbin(int a, int b);

//	void    wolnum(char ii[KK][KK][KK], int c);
//	void    wru(char *c);
//	void	xtoasc(int n);
int     ycc(int i);

//char    xr[DS] = "121220101221200000101000100";
//char    xp[DS] = "532337242335361411252611214"; /* xenophilic	*/
//char    xq[DS] = "135337575337326766575766564"; /* xenophobic	*/
//char    xs[DS] = "135135135326326326564564564"; /* s-xenophobic */
char	xt[DS] = "642642642451451451213213213"; /* s-xenophilic	*/

NXDefaultsVector defaults = {
  {"well0","1.0,0.0,0.0"},
  {"well1","0.0,1.0,0.0"},
  {"well2","0.0,0.0,1.0"},
  {"well3","0.5,0.5,0.0"},
 // {"path" "/seagate/McIntosh/Sealcau/3/nxlcau31"},
  {NULL,NULL}
  };
char colorwells[KK][6] = {"well0", "well1", "well2", "well3"};



@implementation RulePanel


/* ------------  A P P   I N I T I A L I Z A T I O N   --------------- */

- appWillInit:sender
{
// printf("appWillInit\n");
return self;
}

- appDidInit:sender 
{
char   c[20], *df;
int    i;
double red, green, blue;
struct tm  *timeptr;

time_t  secsnow;
  printf("appDidInit = nxlcau42\n");
  rule42(); /* printf("rule42\n"); */
  asctobin();
  ttzero();
  stzero();
  gfzero();
  [self setAllRules: self];
//    wru(c);
//    [ruleNumber setStringValue: c];
    [self showProbability: pSliders];

   time(&secsnow);
   timeptr = localtime(&secsnow);
   sprintf(c,"%d-%d-19%02d\n",
	((timeptr->tm_mon) + 1), 
	timeptr->tm_mday,
        timeptr->tm_year);
   [tiDat setStringValue: c];

//*   [dbguph rijnReset: self];

  NXRegisterDefaults("NXLCAU42Defaults",defaults);
  NXUpdateDefaults();
  for (i=0; i<KK; i++) {
   df=NXGetDefaultValue("NXLCAU42Defaults",colorwells[i]);
   sscanf(df,"%6lf,%6lf,%6lf",&red,&green,&blue); /* don't use %F */
   colst[i]=NXConvertRGBToColor(red,green,blue);
   printf("%s: %s\n",colorwells[i],df);
    }
  [[NXColorPanel sharedInstance: YES] setContinuous: YES];

  [browser getTitleFromPreviousColumn: YES];
  [browser setDoubleAction: @selector(copyAndRunREC:)];
  [browser setPath: "/demonstrations"];
  /* initialize r_vst with selected standard procedures */ 
    rec_c(idef[0],xprg[0],XLEN,dtbl);
    r_vst['a']=xprg[0];

//  chdir("/seagate/McIntosh/Sealcau/3/nxlcau31");

return self;
}

- appWillTerminate:sender
{return self;}

- awakeFromNib 
{
printf("awaking from nib\n");
return self;
}

- setUpWell: well color: (NXColor)aColor tag: (int)aTag 
{
  [well setColor: aColor];
  [well setTag: aTag];
  [well setContinuous: YES];
return self;
}

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadEquivalence:sender 
{
  [self loadLowerPanel: equivRuleBox];
return self;
}

- loadSubset:sender 
{
  [self loadLowerPanel: subsetRuleBox];
return self;
}

- loadArithmetic:sender 
{
  [self loadLowerPanel: arithmRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox 
{NXRect bxRect, loRect;
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: [thisRuleBox contentView]];
  loRect.origin.x=(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - -    R U L E   P A N E L   - - - - - - - - - - */

- protectGenRule:sender
{int i, ii, j, jj, k, i0, i1, i2, i3, i4;
  ii= i=[sender selectedRow];
  jj= j=[sender selectedCol];
  i4=j%KK; j/=KK;
  i3=j%KK; j/=KK;
  i2=j%KK; j/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
    k=auxrule[i0][i1][i2][i3][i4];
    [[ascruButtons cellAt: ii: jj] setIntValue: NO];
    [[ascruButtons cellAt: ii: jj] setIcon: iquon(k)];
    [[ascruButtons cellAt: ii: jj] setTitle: texth(k)];
    [[ascruButtons cellAt: ii: jj] setTag: k];
    [[ascruButtons cellAt: ii: jj] setIconPosition: NX_ICONONLY];
//      for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
//      for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2][i3][i4]=!k;
return self;
}

- relatedRule:sender
{ char    ii[12][KK][KK][KK][KK][KK], wnum[12][10], *titl;
  int	j, k, l, jj[KK];
    l=allperm(wnum,ii,ascrule);
    titl=[[sender selectedCell] title];
    if (strcmp(titl,"reflected")==0)      {k=6;}
    else if (strcmp(titl,"flip")==0)      {k=3;}
    else if (strcmp(titl,"cycle")==0)     {k=1;}
    else if (strcmp(titl,"least")==0)     {k=l;}
    else    k=0;
    chrucopy(ascrule,ii[k],'w');
    [self setAllRules: self];
    if ([changeLine state]) {
      l=vecperm(jj,k);
      for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
      if (l) {
        for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
        for (j=0; j<AL; j++) arr1[j]=arr2[j];
        }
      }
   printf ("related rules\n");
//   for (k=0; k<12; k++) printf("%s\n",wnum[k]);
  return self;
}


/*  generate a table of permutations of a given rule      */
/*  and report the index of the rule with smallest wru    */
/*  wn - array to be filled with 9-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images  */
/*  ru - reference KK8KK8KK table - e.g. ascrule	  */
/*  return value is the index of the least of all these	  */
/*  that is, wn[...] is the number, ii[...] is the rule   */
int allperm(wn,ii,ru)
char wn[12][10], ii[][KK][KK][KK][KK][KK], ru[KK][KK][KK][KK][KK]; {
int k, l;
  chrucopy(ii[ 0],ru,     'w'); /* identity */
  chrucopy(ii[ 1],ru,     'y'); /* (012)    */
  chrucopy(ii[ 2],ii[1],  'y'); /* (021)    */  
  chrucopy(ii[ 3],ii[0],  't'); /* (12)     */
  chrucopy(ii[ 4],ii[1],  't'); /* (20)     */
  chrucopy(ii[ 5],ii[2],  't'); /* (01)     */  
  chrucopy(ii[ 6],ii[0],  'r'); /* reflect  */
  chrucopy(ii[ 7],ii[1],  'r'); /* (012)r   */
  chrucopy(ii[ 8],ii[2],  'r'); /* (021)r   */
  chrucopy(ii[ 9],ii[3],  'r'); /* (12)r    */
  chrucopy(ii[10],ii[4],  'r'); /* (20)r    */
  chrucopy(ii[11],ii[5],  'r'); /* (01)r    */
  for (k=0, l=0; k<12; k++) {
//    wrru(wn[k],ii[k]);
    if (strlen(wn[k]) > strlen(wn[l])) continue;
    if (strlen(wn[k]) < strlen(wn[l])) {l=k; continue;}
    if (strcmp(wn[k],wn[l]) < 0) l=k;
    }
  return l;
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n; {int i, k, l;
  l=!(n<6); k=(l?n-6:n);
  switch (k) {
    case 0: for (i=0; i<KK; i++) ii[i]=i; break;
    case 1: for (i=0; i<KK; i++) ii[i]=ycc(i); break;
    case 2: for (i=0; i<KK; i++) ii[i]=cyy(i); break;
    case 3: for (i=0; i<KK; i++) ii[i]=fli(i); break;
    case 4: for (i=0; i<KK; i++) ii[i]=fli(ycc(i)); break;
    case 5: for (i=0; i<KK; i++) ii[i]=fli(cyy(i)); break;
    default: for (i=0; i<KK; i++) ii[i]=i; break;}
  return l;
}

/* copy a related (character) rule  */
/* c = w - no change		   */
/* c = y - cyclic permutation	   */
/* c = r - reflected		   */
/* c = t - transpose 1&2	   */

void chrucopy(ii,jj,c)
char ii[KK][KK][KK][KK][KK], jj[KK][KK][KK][KK][KK], c; {
int i0, i1, i2, i3, i4;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
       for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++)
         for (i3=0; i3<KK; i3++)
          for (i4=0; i4<KK; i4++) 
      ii[i0][i1][i2][i3][i4]=jj[i0][i1][i2][i3][i4];
      break;
    case 'y':
     for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
       for (i2=0; i2<KK; i2++)
        for (i3=0; i3<KK; i3++)
         for (i4=0; i4<KK; i4++) 
ii[i0][i1][i2][i3][i4]=ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)][cyy(i3)][cyy(i4)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
       for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++)
         for (i3=0; i3<KK; i3++)
	  for (i4=0; i4<KK; i4++) 
        ii[i0][i1][i2][i3][i4]=jj[i4][i3][i2][i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
       for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++)
 	 for (i3=0; i3<KK; i3++)
	  for (i4=0; i4<KK; i4++) 
 ii[i0][i1][i2][i3][i4]=fli(jj[fli(i0)][fli(i1)][fli(i2)][fli(i3)][fli(i4)]);
     break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '3';
	case '3': return '1';
	case 0: return 0;
	case 1: return 2; 
	case 2: return 3;
	case 3: return 1;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
	case 3: return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '2';
	case '1': return '3'; 
	case '2': return '0';
	case '3': return '1';
	case 0: return 2;
	case 1: return 3; 
	case 2: return 0;
	case 3: return 1;
	default:  return '0';}
}

/* create the rule defined by the "symmetric rule" panel 
- symRule:sender 
{
int j000,j001,j002,j003,j010,j011,j012,j013;
int j020,j021,j022,j023,j030,j031,j032,j033;
int j100,j101,j102,j103,j110,j111,j112,j113;
int j120,j121,j122,j123,j130,j131,j132,j133;
int j200,j201,j202,j203,j210,j211,j212,j213;
int j220,j221,j222,j223,j230,j231,j232,j233;
int j300,j301,j302,j303,j310,j311,j312,j313;
int j320,j321,j322,j323,j330,j331,j332,j333;

int i0, i1, i2, i3, i4, j0, j1, r;

j000=[[S000 selectedCell] tag];
j001=[[S001 selectedCell] tag];
j002=[[S002 selectedCell] tag];
j003=[[S003 selectedCell] tag];
j010=[[S010 selectedCell] tag];
j011=[[S011 selectedCell] tag];
j012=[[S012 selectedCell] tag];
j013=[[S013 selectedCell] tag];
j020=[[S020 selectedCell] tag];
j021=[[S021 selectedCell] tag];
j022=[[S022 selectedCell] tag];
j023=[[S023 selectedCell] tag];
j030=[[S030 selectedCell] tag];
j031=[[S031 selectedCell] tag];
j032=[[S032 selectedCell] tag];
j033=[[S033 selectedCell] tag];
j100=[[S100 selectedCell] tag];
j101=[[S101 selectedCell] tag];
j102=[[S102 selectedCell] tag];
j103=[[S103 selectedCell] tag];
j110=[[S110 selectedCell] tag];
j111=[[S111 selectedCell] tag];
j112=[[S112 selectedCell] tag];
j113=[[S113 selectedCell] tag];
j120=[[S120 selectedCell] tag];
j121=[[S121 selectedCell] tag];
j122=[[S122 selectedCell] tag];
j123=[[S123 selectedCell] tag];
j130=[[S130 selectedCell] tag];
j131=[[S131 selectedCell] tag];
j132=[[S132 selectedCell] tag];
j133=[[S133 selectedCell] tag];
j200=[[S200 selectedCell] tag];
j201=[[S201 selectedCell] tag];
j202=[[S202 selectedCell] tag];
j203=[[S203 selectedCell] tag];
j210=[[S210 selectedCell] tag];
j211=[[S211 selectedCell] tag];
j212=[[S212 selectedCell] tag];
j213=[[S213 selectedCell] tag];
j220=[[S220 selectedCell] tag];
j221=[[S221 selectedCell] tag];
j222=[[S222 selectedCell] tag];
j223=[[S223 selectedCell] tag];
j300=[[S300 selectedCell] tag];
j301=[[S301 selectedCell] tag];
j302=[[S302 selectedCell] tag];
j303=[[S303 selectedCell] tag];
j310=[[S310 selectedCell] tag];
j311=[[S311 selectedCell] tag];
j312=[[S312 selectedCell] tag];
j313=[[S313 selectedCell] tag];
j320=[[S320 selectedCell] tag];
j321=[[S321 selectedCell] tag];
j322=[[S322 selectedCell] tag];
j323=[[S323 selectedCell] tag];
j330=[[S330 selectedCell] tag];
j331=[[S331 selectedCell] tag];
j332=[[S332 selectedCell] tag];
j333=[[S333 selectedCell] tag];
printf("%d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n, %d, %d, %d, %d, %d, %d, %d, %d\n",	j000,j001,j002,j003,j010,j011,j012,j013,j020,j021,j022,j023,j030,j031,j032,j033,j100,j101,j102,j103,j110,j111,j112,j113,j120,j121,j122,j123,j130,j131,j132,j133,j200,j201,j202,j203,j210,j211,j212,j213,j220,j221,j222,j223,j230,j231,j232,j233,j300,j301,j302,j303,j310,j311,j312,j313,j320,j321,j322,j323,j330,j331,j332,j333);
  for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
          for (i2=0; i2<KK; i2++)
              for (i3=0; i3<KK; i3++)
		  for (i4=0; i4<KK; i4++) {
    j0=KK+i2-i1-i0;
    j1=KK+i4-i3-i2;
    r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
    r+=j0*j1*(j11+j0*j21+j1*j12);
    r+=j0*j0*j1*j1*j22;
    switch([[sIncr selectedCell] tag]) {
      case 0: r+=i0; break;
      case 1: r+=i1; break;
      case 2: r+=(KK-i0)+(KK-i1); break;
      case 3: break;
      default: break;}
    ascrule[i4][i3][i2][i1][i0]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }
*/

//- readWRule:sender 
//{char *c;
//  c=[sender stringValue];
//  if (longwolftoasc(c)) [self setAllRules: self];
//     else[ruleNumber setStringValue: "invalid"];
//  return self;
//}

//int longwolftoasc(char *c) {
//char d[KK*KK], e;
//int  i, l, n, i0, i1;
//  l=strlen(c);
//  for (i=0; i<KK*KK; i++) d[i]=0;
//  for (i=0; i<l; i++) {
//    e=c[i];
//         if ('0' <= e  &&  e <= '9') n=e-'0';
//    else if ('a' <= e  &&  e <= 'q') n=e-'a'+10;
//    else if ('A' <= e  &&  e <= 'Q') n=e-'A'+10;
//    else    return FALSE;
//    d[KK*KK-l+i]=n;
//    }
//  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) {
//    n=d[KK*KK-i0*KK-i1-1];
//    ascrule[i0][i1][0]='0'+n%KK; n/=KK;
//    ascrule[i0][i1][1]='0'+n%KK; n/=KK;
//    ascrule[i0][i1][2]='0'+n%KK;
//    }
//  return TRUE;
//}

- setRule:sender 
{char ch[30]; int i, ii, j, jj, i0, i1, i2, i3, i4, k, c;
//  wru(ch);
//   [ruleNumber setStringValue: ch];
   ii=i=[sender selectedRow];
   jj=j=[sender selectedCol];
   printf("%d: %d\n",i,j);
    i4=j%KK; j/=KK;
    i3=j%KK; j/=KK;
    i2=j%KK; j/=KK;
    i1=i%KK; i/=KK;
    i0=i%KK; i/=KK;
    k=ascrule[i0][i1][i2][i3][i4];
    k=(k+1)%KK;
    ascrule[i0][i1][i2][i3][i4]='0'+k;
//    j=KK*((KK*KK*KK*i0)+(KK*KK*i1)+(KK*i2)+i3)+i4;
//      ii = j/64;
//      jj = j%64;
//    k=ascrule[i0][i1][i2][i3][i4];         	
//         [[ascruButtons cellAt:ii:jj] setIntValue: NO];
//         [[ascruButtons cellAt:ii:jj] setIcon: iquon(k)];
//         [[ascruButtons cellAt:ii:jj] setTitle: texth(k)];
//         [[ascruButtons cellAt:ii:jj] setTag: k];
//         [[ascruButtons cellAt:ii:jj] setIconPosition: NX_ICONONLY];
//  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
//  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender 
{char ch[30], k; int i, j, ii, jj, i0, i1, i2, i3, i4;
//   wru(ch);
//   [ruleNumber setStringValue: ch];
  asctobin();
     for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
       for (i2=0; i2<KK; i2++)
        for (i3=0; i3<KK; i3++)
         for (i4=0; i4<KK; i4++) {
      j=KK*((KK*KK*KK*i0)+(KK*KK*i1)+(KK*i2)+i3)+i4;
      ii = j/64;
      jj = j%64;
      k=binrule[i0][i1][i2][i3][i4];
        [[ascruButtons cellAt: ii: jj] setIntValue: NO];
    [[ascruButtons cellAt: ii: jj] setIcon: iquon(k)];
    [[ascruButtons cellAt: ii: jj] setTitle: texth(k)];
    [[ascruButtons cellAt: ii: jj] setTag: k];
    [[ascruButtons cellAt: ii: jj] setIconPosition: NX_ICONONLY];
    }
//   wru(ch);
//   [ruleNumber setStringValue: ch];
   [self nxasfreq];
   if      (istot()==1) [totlRef setStringValue: "totalistic"]; 
   else if (isstot()==1) [totlRef setStringValue: "semitotalistic"];
      else [totlRef setStringValue: " "];
return self;
}

- freeAllRules:sender 
{
int i, j, k; 
    for (i=0; i<16; i++) for (j=0; j<64; j++){ 
        [[ascruButtons cellAt: i: j] setIntValue: NO];
        [[ascruButtons cellAt:i:j] setIcon: "0cell"];
        [[ascruButtons cellAt:i:j] setTitle: "0"];
        [[ascruButtons cellAt:i:j] setTag: 0];
        [[ascruButtons cellAt:i:j] setIconPosition: NX_ICONONLY];
     }
//      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender 
{
int i, j, k;
  asczero(); 
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender 
{
int i, j, k;
  granrule();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPRules:sender 
{
int i, j, k;
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* for 3-state automata, group the neighborhoods by threes and  */
/* use ASCII letters base 27 - that is, 0-9, A-Q.	        */
//void wru(c) char *c; {int  i, j;
//int  i0, i1;
//j=0;
//for (i0=0; i0<KK; i0++)
//for (i1=0; i1<KK; i1++)
//  {
//  i= 9*(ascrule[i0][i1][2]-'0')
//    +3*(ascrule[i0][i1][1]-'0')
//    +  (ascrule[i0][i1][0]-'0')
//    +'0';
//  if (i>'9') i=i+('A'-':');
//  c[KK*KK-j-1]=i;
//  j++;
//  }
//c[KK*KK]=0;
//}

/* calculate wru from an argument rule  */
//void wrru(c,ru) char *c, ru[KK][KK][KK][KK][KK]; {
//int  i, j;
//int  i0, i1;
//j=0;
//for (i0=0; i0<KK; i0++)
//for (i1=0; i1<KK; i1++)
//  {     
//  i= 9*(ru[i0][i1][2]-'0')
//   +3*(ru[i0][i1][1]-'0')
//   +  (ru[i0][i1][0]-'0')
//   +'0';
//  if (i>'9') i=i+('A'-':');
//  c[KK*KK-j-1]=i;
//  j++;
//  }
//c[KK*KK]=0;
//}

/* generate a random rule */
void granrule() {int i, i0, i1, i2, i3, i4;
     for (i0=0; i0<KK; i0++)
     for (i1=0; i1<KK; i1++)
     for (i2=0; i2<KK; i2++)
     for (i3=0; i3<KK; i3++)
     for (i4=0; i4<KK; i4++) {
         i=(random()&0xFF)%KK;
         ascrule[i0][i1][i2][i3][i4]=i+'0';
  }
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2, i3, i4, i, j;
     i=0; j=0;
     for (i0=0; i0<KK; i0++)
     for (i1=0; i1<KK; i1++)
     for (i2=0; i2<KK; i2++)
     for (i3=0; i3<KK; i3++)
     for (i4=0; i4<KK; i4++)
 {
  if (i%8 == 0) j=random(); i++;
  if (auxrule[i0][i1][i2][i3][i4]==0) ascrule[i0][i1][i2][i3][i4]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender 
{int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender
  {double p[KK]; int i;
     for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
     ranblin(p[0],p[1],p[2],p[3]);
     return self;
  }

- sCellLine:sender {putionj(1,0); return self;}

- dCellLine:sender {putionj(2,0); return self;}

- tCellLine:sender {putionj(3,0); return self;}

- uniformLine:sender
{
  ranblin(0.25,0.25,0.25,0.25);
return self;
}

- useRECLine:sender 
{
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
return self;
}

- runRECLine:sender 
{
printf("hello from runRec\n");
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) 
	[RECValue setStringValue: "T"]; else [RECValue setStringValue: "F"];
return self;
}

/* - - - - - - - -   D E M O N S T R A T I O N   R U L E S   - - - - - - - - */

- setDemo:sender 
{char ch[20];
//   wru(ch);
//   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - - - -   G F ( 3 )   R U L E   - - - - - - - - - - - - */

//- setMCoeff:sender 
//{int s, t;
//    s=[sender selectedRow];
//    t=[sender tag];
//    gf3rule[t]=s+'0';
//    [gfWindow setDocEdited:YES];
//return self;
//}

//- setVCoeff:sender 
//{int s, t;
//    s=[sender selectedRow];
//    t=[sender tag];
//    gf3rule[t+9]=s+'0';
//    [gfWindow setDocEdited:YES];
//return self;
//}

//- setSCoeff:sender 
//{int s;
//    s=[sender selectedRow];
//    gf3rule[12]=s+'0';
//    [gfWindow setDocEdited:YES];
//return self;
//}

//- enterGF3Rule:sender
//{char b[10][10], c[80]; int i;
//DrMc  int i; for (i=0; i<13; i++) printf("%1d ",gf3rule[i]); printf("\n");
//    gftoasc();
//    i=gf3rule[0]-'0';
//	 if (i==0) b[0][0]=0; else sprintf(b[0],"%dx^2+ ",i);
//    i=(gf3rule[1]-'0'+gf3rule[3]-'0')%KK;
//	 if (i==0) b[1][0]=0; else sprintf(b[1],"%dxy +",i);
//    i=(gf3rule[2]-'0'+gf3rule[6]-'0')%KK;
//	 if (i==0) b[2][0]=0; else sprintf(b[2],"%dxz +",i);
//    i=gf3rule[4]-'0';
//	 if (i==0) b[3][0]=0; else sprintf(b[3],"%dy^2+ ",i);
//    i=(gf3rule[5]-'0'+gf3rule[7]-'0')%KK;
//	 if (i==0) b[4][0]=0; else sprintf(b[4],"%dyz +",i);
//    i=gf3rule[8]-'0';
//	 if (i==0) b[5][0]=0; else sprintf(b[5],"%dz^2+ ",i);
//    i=gf3rule[9]-'0';
//	 if (i==0) b[6][0]=0; else sprintf(b[6],"%dx+ ",i);
//    i=gf3rule[10]-'0';
//	 if (i==0) b[7][0]=0; else sprintf(b[7],"%dy+",i);
//    i=gf3rule[11]-'0';
//	 if (i==0) b[8][0]=0; else sprintf(b[8],"%dz +",i);
//    i=gf3rule[12]-'0';
//	 if (i==0) b[9][0]=0; else sprintf(b[9],"%d",i);
//    sprintf(c,"%s%s%s%s%s%s%s%s%s%s",b[0],b[1],b[2],b[3],b[4],b[5],b[6],
//					b[7],b[8],b[9]);
//    [ruleFormula setStringValue: c];
//    [self setAllRules:self];
//    [gfWindow setDocEdited:NO];
//return self;
//}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender
{
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    strule[t%KK][t/KK]=s+'0';
    [stWindow setDocEdited:YES];
    sttoasc();
  return self;
}
 
- enterSemiRule:sender
{
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender
{
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender
{
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

/*
 *	subset  code
 *	------  ----
 *	empty - 0
 *	0	1
 *	1	2
 *	2	4
 *	0,1	3
 *	0,2	5
 *	1,2	6
 *	0,1,2	7
 *
 *     rule     --- phobic  -- philic  -- sphobic  -- sphilic
 *	000     0      (1)  1,2   (6)  0      (1)  1,2   (6)  
 *	001	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	002	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	010	0,1    (3)  2     (4)  0      (1)  1,2   (6)  
 *	011	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	012	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	020	0,2    (5)  1     (2)  0      (1)  1,2   (6)  
 *	021	0,1,2  (7)  	  (0)  0,1    (3)  2     (4)  
 *	022	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 
 *	100	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	101	0,1    (3)  2     (4)  1      (2)  0,2   (5)  
 *	102	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	110	0,1    (3)  2     (4)  0,1    (3)  2     (4)  
 *	111	1      (2)  0,2   (5)  1      (2)  0,2   (5)  
 *	112	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	120	0,1,2  (7)        (0)  0,1    (3)  2     (4)  
 *	121	1,2    (6)  0     (1)  1      (2)  0,2   (5)  
 *	122	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 	
 *	200	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	201	0,1,2  (7)  	  (0)  1,2    (6)  0	 (1) 
 *	202	0,2    (5)  1     (2)  2      (4)  0,1   (3)  
 *	210	0,1,2  (7)  	  (0)  0,2    (5)  1	 (2) 
 *	211	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	212	1,2    (6)  0     (1)  2      (4)  0,1   (3)  
 *	220	0,2    (5)  1     (2)  0,2    (5)  1	 (2) 	
 *	221	1,2    (6)  0     (1)  1,2    (6)  0	 (1) 
 *	222	2      (4)  0,1   (3)  2      (4)  0,1   (3)  
 */ 

- xenophilic:sender 
{
  ranvachrul(xt);
  [self setAllRules: self];
return self;
}

- xenophobic:sender 
{int i, k, i0, i1, i2, i3, i4, ix[2]; char ru[4][3][3][3][3][3];
  for (i=0; i<5; i++) runowows(ru[i],[[obBnry cellAt: i: 0] intValue]);
  for (i=0, k=0; i<3; i++) if (ru[i][0][0][0][0][0]==ru[i][1][1][1][1][1]) 
	{[[obBnry cellAt: i: 0] setStringValue: "***"]; k=1;}
  if (k==1) return self;
  ascrule[0][0][0][0][0]='0';
  ascrule[1][1][1][1][1]='1';
  ascrule[2][2][2][2][2]='2';
  ascrule[3][3][3][3][3]='3';
  ix[0]=0; ix[1]=1;
  for (i0=0; i0<3; i0++) for (i1=0; i1<3; i1++) for (i2=0; i2<3; i2++) for (i3=0; i3<3; i3++) for (i4=0; i4<3; i4++) 
ascrule[ix[i0]][ix[i1]][ix[i2]][ix[i3]][ix[i4]]=ix[ru[0][i0][i1][i2][i3][i4]-'0']+'0';
  ix[0]=2; ix[1]=0;
  for (i0=0; i0<3; i0++) for (i1=0; i1<3; i1++) for (i2=0; i2<3; i2++) for (i3=0; i3<3; i3++) for (i4=0; i4<3; i4++) 
ascrule[ix[i0]][ix[i1]][ix[i2]][ix[i3]][ix[i4]]=ix[ru[1][i0][i1][i2][i3][i4]-'0']+'0';
  ix[0]=1; ix[1]=2;
  for (i0=0; i0<3; i0++) for (i1=0; i1<3; i1++) for (i2=0; i2<3; i2++) for (i3=0; i3<3; i3++) for (i4=0; i4<3; i4++) 
 	ascrule[ix[i0]][ix[i1]][ix[i2]][ix[i3]][ix[i4]]=ix[ru[2][i0][i1][i2][i3][i4]-'0']+'0';
/*  ascrule[0][1][2]=[[obPerm cellAt: 0: 0] intValue]+'0';
  ascrule[0][2][1]=[[obPerm cellAt: 1: 0] intValue]+'0';
  ascrule[1][0][2]=[[obPerm cellAt: 2: 0] intValue]+'0';
  ascrule[1][2][0]=[[obPerm cellAt: 3: 0] intValue]+'0';
  ascrule[2][0][1]=[[obPerm cellAt: 4: 0] intValue]+'0';
  ascrule[2][1][0]=[[obPerm cellAt: 5: 0] intValue]+'0';
  ascrule[3][
  ascrule[3]
*/
  [self setAllRules: self];
return self;
}

//- randphobic:sender 
//{
//  ranvachrul(xq);
//  [[obPerm cellAt: 0: 0] setIntValue: ascrule[0][1][2]-'0'];
//  [[obPerm cellAt: 1: 0] setIntValue: ascrule[0][2][1]-'0'];
//  [[obPerm cellAt: 2: 0] setIntValue: ascrule[1][0][2]-'0'];
//  [[obPerm cellAt: 3: 0] setIntValue: ascrule[1][2][0]-'0'];
//  [[obPerm cellAt: 4: 0] setIntValue: ascrule[2][0][1]-'0'];
//  [[obPerm cellAt: 5: 0] setIntValue: ascrule[2][1][0]-'0'];
//  asctobin();
//  [[obBnry cellAt: 0: 0] setIntValue: wolbin(0,1)];
//  [[obBnry cellAt: 1: 0] setIntValue: wolbin(0,2)];
//  [[obBnry cellAt: 2: 0] setIntValue: wolbin(1,2)];
//return self;
//}

int ran2of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
 else return c;
}

int ran3of3(a,b,c,d) int a, b, c, d; {
if ((random()%1001)<250) return a;
if ((random()%1001)<500) return b;
if ((random()%1001)<750) return c;
return d;
}

/* generate a random variable choice rule */
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i4, i;
i=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  switch (c[KK*((KK*KK*KK*i0)+(KK*KK*i1)+(KK*i2)+i3)+i4]-'0') {
    case 0: break;
    case 1: i=0; break;
    case 2: i=1; break;
    case 4: i=2; break;
    case 3: i=ran2of3(0,1,2); break;
    case 6: i=ran2of3(1,2,3); break;
    case 5: i=ran2of3(2,0,1); break;
    case 7: i=ran3of3(0,1,2,3); break;
    default: i=0; break;}
    ascrule[i0][i1][i2][i3][i4]='0'+i;
  }
}

//- allClans:sender 
//{int i, j, k, i0, i1, i2, i3, i4, i5, ix[2];
//char ru[3][2][2][2], ch[10];
//char ii[12][KK][KK][KK], wnum[12][10];
//  for (i=0; i<(KK*(KK-1))/2; i++) runowows(ru[i],150);
//  ascrule[0][0][0]='0';
//  ascrule[1][1][1]='1';
//  ascrule[2][2][2]='2';
//  ix[0]=0; ix[1]=1;
//  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
//	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[0][i0][i1][i2]-'0']+'0';
//  ix[0]=2; ix[1]=0;
//  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
//	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[1][i0][i1][i2]-'0']+'0';
//  ix[0]=1; ix[1]=2;
//  for (i0=0; i0<2; i0++) for (i1=0; i1<2; i1++) for (i2=0; i2<2; i2++) 
//	ascrule[ix[i0]][ix[i1]][ix[i2]]=ix[ru[2][i0][i1][i2]-'0']+'0';
//  j=0;
//  for (i0=0; i0<KK; i0++) 
//  for (i1=0; i1<KK; i1++) 
//  for (i2=0; i2<KK; i2++) 
//  for (i3=0; i3<KK; i3++) 
//  for (i4=0; i4<KK; i4++) 
//  for (i5=0; i5<KK; i5++) {
//     ascrule[0][1][2]=i0+'0';
//     ascrule[0][2][1]=i1+'0';
//     ascrule[1][0][2]=i2+'0';
//     ascrule[1][2][0]=i3+'0';
//     ascrule[2][0][1]=i4+'0';
//     ascrule[2][1][0]=i5+'0';
//     k=allperm(wnum,ii,ascrule);
//     wru(ch);
//     printf("%3d: %s   %s\n",++j,ch,wnum[k]);
//    }
//return self;
//}

/* - - - - - - - - -    E Q U I V A L E N C E   R U L E    - - - - - - - - - */

//- equivalence:sender 
//{char ru[2][2][2], iy[2], iz; int i, i0, i1, i2, ix[KK], choi, p;
//  runowows(ru,[eqFactor intValue]);
//  choi=[eqChoices intValue];
//  p=[eqPair selectedRow];
//  switch (p) {
//    case 0:  ix[0]=0; ix[1]=0; ix[2]=1;
//	     iy[0]='0'; iy[1]='1';
//	     iz='2'; break;
//    case 1:  ix[0]=0; ix[1]=1; ix[2]=0;
//	     iy[0]='0'; iy[1]='2';
//	     iz='1'; break;
//    case 2:  ix[0]=1; ix[1]=0; ix[2]=0;
//	     iy[0]='1'; iy[1]='2';
//	     iz='0'; break;
//    default: printf("unidentified pair\n"); break;}
//  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
//    i=ru[ix[i0]][ix[i1]][ix[i2]];
//    ascrule[i0][i1][i2][i3][i4]=(i=='0'?iy[choi%2]:iz);
//    choi/=2;
//    }
//  [self setAllRules: self];
//return self;
//}

//- ranqul:sender 
//{
//  switch ([sender selectedRow]) {
//    case 0: [eqFactor setIntValue: random()%256]; break;
//    case 1: [eqChoices setIntValue: random()%256]; break;
//    default: printf("unidentified random choice\n"); break;}
//return self;
//}

/* - - - - - -    A R I T H M E T I C   C O M B I N A T I O N    - - - - - - */

//- arithmCombs:sender 
//{
//birular aza, bzb, czc;
//  [self readWRule: [twoRules cellAt: 0: 0]];
//  asctobin();
//  bincopy(&aza,(birular)binrule);
//  binprint(aza);
//  [self readWRule: [twoRules cellAt: 1: 0]];
//  asctobin();
//  bincopy(&bzb,(birular)binrule);
//  binprint(bzb);
//  switch ([sender selectedRow]) {
//    case 0: binsum(&czc,aza,bzb); break;
//    case 1: binprod(&czc,aza,bzb); break;
//    default: printf("arithCombs\n"); break;}
//  binprint(czc);
 // bincopy((birular)binrule,czc); /* se quito & */
//  bintoasc();
//  [self setAllRules: self];
//  binprint((birular)binrule);
//return self;
//}

//- initTwoRules:sender 
//{char ch[20];
//   granrule();
//   wru(ch);
//   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
//return self;
//}

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz, rx;
{int i; for (i=0; i<KK*KK*KK*KK*KK; i++) rz->one[i]=rx.one[i];}

/* fill ascrule from binrule */
void bintoasc() 
{int i0, i1, i2, i3, i4; 
  for (i0=0; i0<KK; i0++) 
  for (i1=0; i1<KK; i1++) 
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) 
    ascrule[i0][i1][i2][i3][i4]=binrule[i0][i1][i2][i3][i4]+'0';
}

/* sum two binary rules mod KK */
//void binsum(rz,rx,ry) birular *rz, rx, ry;
//{int i; for (i=0; i<KK*KK*KK; i++) rz->one[i]=(rx.one[i]+ry.one[i])%KK;}

/* multiply two binary rules mod KK */
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<KK*KK*KK*KK*KK; i++) rz->one[i]=(rx.one[i]*ry.one[i])%KK;}

/* print a binary rule (all 27 numbers) */
void binprint(rz) birular rz; {int i;
for (i=0; i<KK*KK*KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
printf("\n");
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

//- deZign:sender 
//{int k, n, i0, i1, i2;
//    k=[sender intValue];
//    if (k>=0 && k <=KK) return self;
//    k=[sender tag];
//    i2=k%KK; k/=KK;
//    i1=k%KK; k/=KK;
//    i0=k%KK;
//    switch ([designRef selectedRow]) {
//      case 0: k=i0; break;
//      case 1: k=i1; break;
//      case 2: k=i2; break;
//      default: k=0; break;}
//    n=[designPrm selectedRow];
//    k=permut(k,n);
//    [sender setIntValue: k];
//    [ddWindow setDocEdited:YES];
//return self;
//}

//- clearDesign:sender 
//{
//id  z;
//int i;
//  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
//return self;
//}

//- copyToDesign:sender 
//{
//id  z;
//int i0, i1, i2;
//  z=zeZeZe;
//  for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) for (i2=0; i2<KK; i2++) {
//    [z setIntValue: ascrule[i0][i1][i2]-'0'];
//    z=[z nextText];
//    }    
//return self;
//}

//- enterDesign:sender 
//{
//int i, k, i0, i1, i2;
//id  z;
//  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
//    k=i;
//    i2=k%KK; k/=KK;
//    i1=k%KK; k/=KK;
//    i0=k%KK;
//    k=[z intValue];
//    ascrule[i0][i1][i2]=(k<KK?k:0)+'0';
//    auxrule[i0][i1][i2]=(k<KK?1:0);
//    }
//  [self setAllRules: self];
//  [ddWindow setDocEdited:NO];
//return self;
//}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq 
{
int    i, j, i0, i1, i2, i3, i4;
int    stat[KK], stal, stac, star, stax, stay;	/* statistic counts */
int    xe;
double staf[KK], t, pp;

xe=0;
pp=1.0/((double)(DS));
stal=0; stac=0; star=0; stax=0; stay=0;
for (i=0; i<KK; i++) stat[i]=0;
 for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
   for (i2=0; i2<KK; i2++)
    for (i3=0; i3<KK; i3++)
     for (i4=0; i4<KK; i4++) {
  j=ascrule[i0][i1][i2][i3][i4]-'0';
  stat[j]++;
  if (j==i0) stal++;
  if (j==i1) stac++;
  if (j==i2) star++;
  if (j==i3) stax++;
  if (j==i4) stay++;
  if (j==i0 || j==i1 || j==i2 || j==i3 || j==i4) xe++;
  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
	[statIndx setDoubleValue: ((double)stal)*pp at: 0];
	[statIndx setDoubleValue: ((double)stac)*pp at: 1];
	[statIndx setDoubleValue: ((double)star)*pp at: 2];
	[statIndx setDoubleValue: ((double)stax)*pp at: 3];
	[statIndx setDoubleValue: ((double)stay)*pp at: 4];
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}

@end

/* end RulePanel.m */